// src/utils.ts
var parameterName = (operationId) => `Parameter$${operationId}`;
var requestBodyName = (operationId) => `RequestBody$${operationId}`;
var argumentParamsTypeDeclaration = (operationId) => `Params$${operationId}`;
var responseName = (operationId, statusCode) => `Response$${operationId}$Status$${statusCode}`;
var requestContentType = (operationId) => `RequestContentType$${operationId}`;
var responseContentType = (operationId) => `ResponseContentType$${operationId}`;
var isAvailableVariableName = (text) => {
  return /^[A-Za-z_0-9]+$/.test(text);
};
var isFirstCharacterIsValidText = (text) => {
  return /^[A-Za-z]+/.test(text);
};
var escapeText = (text) => {
  if (isAvailableVariableName(text) && isFirstCharacterIsValidText(text)) {
    return text;
  }
  return `"${text}"`;
};
var escapeText2 = (text) => {
  if (isAvailableVariableName(text)) {
    return {
      escaped: false,
      text
    };
  }
  return {
    escaped: true,
    text: `"${text}"`
  };
};

export {
  parameterName,
  requestBodyName,
  argumentParamsTypeDeclaration,
  responseName,
  requestContentType,
  responseContentType,
  isAvailableVariableName,
  isFirstCharacterIsValidText,
  escapeText,
  escapeText2
};
//# sourceMappingURL=chunk-R3KKVR43.js.map