"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  CodeGenerator: () => CodeGenerator
});
module.exports = __toCommonJS(src_exports);
var import_os5 = require("os");

// src/internal/TsGenerator/index.ts
var TsGenerator_exports = {};
__export(TsGenerator_exports, {
  Factory: () => factory_exports,
  Utils: () => utils_exports,
  convertAstToTypeScriptCode: () => convertAstToTypeScriptCode,
  generate: () => generate
});
var import_typescript19 = __toESM(require("typescript"), 1);

// src/internal/Exception/index.ts
var BaseError = class extends Error {
  constructor(message) {
    super(message);
    Object.setPrototypeOf(this, new.target.prototype);
  }
};
var UnSupportError = class extends BaseError {
};
var NotFoundFileError = class extends BaseError {
};
var FeatureDevelopmentError = class extends BaseError {
};
var UndefinedComponent = class extends BaseError {
};
var DevelopmentError = class extends BaseError {
};

// src/internal/TsGenerator/factory/index.ts
var factory_exports = {};
__export(factory_exports, {
  create: () => create44
});
var import_typescript16 = __toESM(require("typescript"), 1);

// src/internal/TsGenerator/factory/ArrowFunction.ts
var create = ({ factory }) => (params) => {
  const node = factory.createArrowFunction(
    void 0,
    params.typeParameters,
    params.parameters,
    params.type,
    params.equalsGreaterThanToken,
    params.body
  );
  return node;
};
var make = (context) => {
  return {
    create: create(context)
  };
};

// src/internal/TsGenerator/factory/BinaryExpression.ts
var import_typescript = __toESM(require("typescript"), 1);
var operators = {
  "+": import_typescript.default.SyntaxKind.PlusToken,
  "=": import_typescript.default.SyntaxKind.EqualsToken
};
var create2 = ({ factory }) => (params) => {
  const node = factory.createBinaryExpression(params.left, operators[params.operator], params.right);
  return node;
};
var make2 = (context) => {
  return {
    create: create2(context)
  };
};

// src/internal/TsGenerator/factory/Block.ts
var create3 = ({ factory }) => (params) => {
  const node = factory.createBlock(params.statements, params.multiLine);
  return node;
};
var make3 = (context) => {
  return {
    create: create3(context)
  };
};

// src/internal/TsGenerator/factory/CallExpression.ts
var create4 = ({ factory }) => (params) => {
  const node = factory.createCallExpression(params.expression, params.typeArguments, params.argumentsArray);
  return node;
};
var make4 = (context) => {
  return {
    create: create4(context)
  };
};

// src/internal/TsGenerator/factory/ClassDeclaration.ts
var import_typescript2 = __toESM(require("typescript"), 1);
var create5 = ({ factory }) => (params) => {
  const node = factory.createClassDeclaration(
    params.export && [factory.createModifier(import_typescript2.default.SyntaxKind.ExportKeyword)],
    factory.createIdentifier(params.name),
    params.typeParameterDeclaration,
    void 0,
    params.members
  );
  return node;
};
var make5 = (context) => {
  return {
    create: create5(context)
  };
};

// src/internal/TsGenerator/factory/ConstructorDeclaration.ts
var create6 = ({ factory }) => (params) => {
  const node = factory.createConstructorDeclaration(void 0, params.parameters || [], params.body);
  return node;
};
var make6 = (context) => {
  return {
    create: create6(context)
  };
};

// src/internal/TsGenerator/factory/ElementAccessExpression.ts
var create7 = ({ factory }) => (params) => {
  const index = typeof params.index === "string" ? factory.createStringLiteral(params.index) : params.index;
  const node = factory.createElementAccessExpression(params.expression, index);
  return node;
};
var make7 = (context) => {
  return {
    create: create7(context)
  };
};

// src/internal/TsGenerator/factory/ExpressionStatement.ts
var create8 = ({ factory }) => (params) => {
  const node = factory.createExpressionStatement(params.expression);
  return node;
};
var make8 = (context) => {
  return {
    create: create8(context)
  };
};

// src/internal/TsGenerator/factory/FunctionTypeNode.ts
var create9 = ({ factory }) => (params) => {
  const node = factory.createFunctionTypeNode(params.typeParameters, params.parameters, params.type);
  return node;
};
var make9 = (context) => {
  return {
    create: create9(context)
  };
};

// src/internal/TsGenerator/factory/Identifier.ts
var create10 = ({ factory }) => (params) => {
  const node = factory.createIdentifier(params.name);
  return node;
};
var make10 = (context) => {
  return {
    create: create10(context)
  };
};

// src/internal/TsGenerator/factory/IndexSignatureDeclaration.ts
var import_typescript3 = __toESM(require("typescript"), 1);
var create11 = ({ factory }) => (params) => {
  const node = factory.createIndexSignature(
    void 0,
    // TODO Feature Development: Refactoring
    [
      factory.createParameterDeclaration(
        void 0,
        void 0,
        factory.createIdentifier(params.name),
        void 0,
        factory.createKeywordTypeNode(import_typescript3.default.SyntaxKind.StringKeyword),
        void 0
      )
    ],
    params.type
  );
  return node;
};
var make11 = (context) => {
  return {
    create: create11(context)
  };
};

// src/internal/TsGenerator/factory/IndexedAccessTypeNode.ts
var create12 = ({ factory }) => (params) => {
  const node = factory.createIndexedAccessTypeNode(params.objectType, params.indexType);
  return node;
};
var make12 = (context) => {
  return {
    create: create12(context)
  };
};

// src/internal/TsGenerator/factory/InterfaceDeclaration.ts
var import_typescript4 = __toESM(require("typescript"), 1);

// src/internal/TsGenerator/factory/utils.ts
var import_os = require("os");
var escapeIdentiferText = (text) => {
  return text.replace(/-/g, "_");
};
var generateComment = (comment, deprecated) => {
  const excapedComment = comment.replace(/\*\//, "\\*\\\\/").replace(/\/\*/, "/\\\\*").replace(/\*\/\*/, "\\*\\/\\*");
  const splitComments = deprecated ? ["@deprecated"].concat(excapedComment.split(/\r?\n/)) : excapedComment.split(/\r?\n/);
  const comments = splitComments.filter((comment2, index) => {
    if (index === splitComments.length - 1 && comment2 === "") {
      return false;
    }
    return true;
  });
  if (comments.length === 1) {
    return {
      hasTrailingNewLine: true,
      value: `* ${comments.join("")} `
    };
  }
  return {
    hasTrailingNewLine: true,
    value: `*${import_os.EOL}${comments.map((comment2) => ` * ${comment2}`).join(import_os.EOL)}${import_os.EOL} `
  };
};

// src/internal/TsGenerator/factory/InterfaceDeclaration.ts
var create13 = ({ factory }) => (params) => {
  const node = import_typescript4.default.factory.createInterfaceDeclaration(
    params.export && [factory.createModifier(import_typescript4.default.SyntaxKind.ExportKeyword)],
    factory.createIdentifier(escapeIdentiferText(params.name)),
    params.typeParameters,
    void 0,
    params.members
  );
  if (params.comment) {
    const comment = generateComment(params.comment, params.deprecated);
    return import_typescript4.default.addSyntheticLeadingComment(node, import_typescript4.default.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
  }
  return node;
};
var make13 = (context) => {
  return {
    create: create13(context)
  };
};

// src/internal/TsGenerator/factory/IntersectionTypeNode.ts
var create14 = ({ factory }) => (params) => {
  const node = factory.createIntersectionTypeNode(params.typeNodes);
  return node;
};
var make14 = (context) => {
  return {
    create: create14(context)
  };
};

// src/internal/TsGenerator/factory/LiteralTypeNode.ts
var import_typescript5 = __toESM(require("typescript"), 1);
var create15 = ({ factory }) => (params) => {
  const createNode = () => {
    if (typeof params.value === "string") {
      const literal = import_typescript5.default.setEmitFlags(factory.createStringLiteral(params.value), import_typescript5.default.EmitFlags.NoAsciiEscaping);
      return factory.createLiteralTypeNode(literal);
    }
    if (typeof params.value === "number") {
      return factory.createLiteralTypeNode(factory.createNumericLiteral(params.value));
    }
    return factory.createLiteralTypeNode(params.value ? factory.createTrue() : factory.createFalse());
  };
  const node = createNode();
  if (params.comment) {
    const comment = generateComment(params.comment);
    return import_typescript5.default.addSyntheticLeadingComment(node, import_typescript5.default.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
  }
  return node;
};
var make15 = (context) => {
  return {
    create: create15(context)
  };
};

// src/internal/TsGenerator/factory/MethodDeclaration.ts
var import_typescript6 = __toESM(require("typescript"), 1);
var create16 = ({ factory }) => (params) => {
  const modifiers = [];
  if (params.private) {
    modifiers.push(factory.createModifier(import_typescript6.default.SyntaxKind.PrivateKeyword));
  } else {
    modifiers.push(factory.createModifier(import_typescript6.default.SyntaxKind.PublicKeyword));
  }
  if (params.async) {
    modifiers.push(factory.createModifier(import_typescript6.default.SyntaxKind.AsyncKeyword));
  }
  const node = factory.createMethodDeclaration(
    modifiers,
    void 0,
    factory.createIdentifier(params.name),
    void 0,
    params.typeParameters,
    params.parameters || [],
    params.type,
    params.body
  );
  if (params.comment) {
    const comment = generateComment(params.comment, params.deprecated);
    return import_typescript6.default.addSyntheticLeadingComment(node, import_typescript6.default.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
  }
  return node;
};
var make16 = (context) => {
  return {
    create: create16(context)
  };
};

// src/internal/TsGenerator/factory/Namespace.ts
var import_typescript7 = __toESM(require("typescript"), 1);

// src/internal/TsGenerator/factory/ModuleBlock.ts
var update = ({ factory }) => (params) => {
  const { node, statements } = params;
  return factory.updateModuleBlock(node, statements);
};

// src/internal/TsGenerator/factory/Namespace.ts
var findStatement = (_context) => (params) => {
  let statement;
  params.node.forEachChild((node) => {
    if (import_typescript7.default.isModuleDeclaration(node) && node.name.text === params.name) {
      statement = node;
    }
  });
  return statement;
};
var create17 = ({ factory }) => (params) => {
  const node = factory.createModuleDeclaration(
    params.export && [factory.createModifier(import_typescript7.default.SyntaxKind.ExportKeyword)],
    factory.createIdentifier(params.name),
    factory.createModuleBlock(params.statements),
    import_typescript7.default.NodeFlags.Namespace
  );
  if (params.comment) {
    const comment = generateComment(params.comment, params.deprecated);
    return import_typescript7.default.addSyntheticLeadingComment(node, import_typescript7.default.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
  }
  return node;
};
var createMultiple = (context) => (params) => {
  const names = params.names.reverse();
  const firstName = names[0];
  const restNames = names.slice(1, names.length);
  const child = create17(context)({
    export: true,
    name: firstName,
    statements: params.statements,
    comment: params.comment,
    deprecated: params.deprecated
  });
  return restNames.reduce((previousStatement, currentName) => {
    return create17(context)({
      export: true,
      name: currentName,
      statements: [previousStatement]
    });
  }, child);
};
var update2 = (context) => (params) => {
  const { factory } = context;
  const { node, statements } = params;
  if (node.body && import_typescript7.default.isModuleBlock(node.body)) {
    const body = update(context)({ node: node.body, statements });
    return factory.updateModuleDeclaration(node, node.modifiers, node.name, body);
  }
  return factory.updateModuleDeclaration(node, node.modifiers, node.name, node.body);
};
var addStatements = (context) => (params) => {
  const { factory } = context;
  const { node, statements } = params;
  if (node.body && import_typescript7.default.isModuleBlock(node.body)) {
    const body = update(context)({ node: node.body, statements: node.body.statements.concat(statements) });
    return factory.updateModuleDeclaration(node, node.modifiers, node.name, body);
  }
  return factory.updateModuleDeclaration(node, node.modifiers, node.name, node.body);
};
var make17 = (context) => {
  return {
    findNamespace: findStatement(context),
    create: create17(context),
    update: update2(context),
    createMultiple: createMultiple(context),
    addStatements: addStatements(context)
  };
};

// src/internal/TsGenerator/factory/NoSubstitutionTemplateLiteral.ts
var create18 = ({ factory }) => (params) => {
  const node = factory.createNoSubstitutionTemplateLiteral(params.text, params.rawText);
  return node;
};
var make18 = (context) => {
  return {
    create: create18(context)
  };
};

// src/internal/TsGenerator/factory/ObjectLiteralExpression.ts
var create19 = ({ factory }) => (params) => {
  const node = factory.createObjectLiteralExpression(params.properties, params.multiLine);
  return node;
};
var make19 = (context) => {
  return {
    create: create19(context)
  };
};

// src/internal/TsGenerator/factory/ParameterDeclaration.ts
var import_typescript8 = __toESM(require("typescript"), 1);
var create20 = ({ factory }) => (params) => {
  const modifiers = (() => {
    if (params.modifiers === "private") {
      return [factory.createModifier(import_typescript8.default.SyntaxKind.PrivateKeyword)];
    }
    if (params.modifiers === "public") {
      return [factory.createModifier(import_typescript8.default.SyntaxKind.PublicKeyword)];
    }
    return;
  })();
  const node = factory.createParameterDeclaration(
    modifiers,
    void 0,
    factory.createIdentifier(params.name),
    params.optional && factory.createToken(import_typescript8.default.SyntaxKind.QuestionToken),
    params.type,
    void 0
  );
  return node;
};
var make20 = (context) => {
  return {
    create: create20(context)
  };
};

// src/internal/TsGenerator/factory/PropertyAccessExpression.ts
var generateExpression = (factory) => {
  return {
    this: factory.createThis()
  };
};
var create21 = ({ factory }) => (params) => {
  let expression = typeof params.expression === "string" ? factory.createIdentifier(params.expression) : params.expression;
  const expressionMap = generateExpression(factory);
  if (typeof params.expression === "string" && params.expression in expressionMap) {
    expression = generateExpression(factory)[params.expression];
  }
  const node = factory.createPropertyAccessExpression(expression, factory.createIdentifier(params.name));
  return node;
};
var make21 = (context) => {
  return {
    create: create21(context)
  };
};

// src/internal/TsGenerator/factory/PropertyAssignment.ts
var import_typescript9 = __toESM(require("typescript"), 1);
var create22 = ({ factory }) => (params) => {
  const node = factory.createPropertyAssignment(params.name, params.initializer);
  if (params.comment) {
    const comment = generateComment(params.comment, params.deprecated);
    return import_typescript9.default.addSyntheticLeadingComment(node, import_typescript9.default.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
  }
  return node;
};
var make22 = (context) => {
  return {
    create: create22(context)
  };
};

// src/internal/TsGenerator/factory/PropertyDeclaration.ts
var create23 = ({ factory }) => (params) => {
  const node = factory.createPropertyDeclaration(
    params.modifiers,
    params.name,
    params.questionOrExclamationToken,
    params.type,
    params.initializer
  );
  return node;
};
var make23 = (context) => {
  return {
    create: create23(context)
  };
};

// src/internal/TsGenerator/factory/PropertySignature.ts
var import_typescript10 = __toESM(require("typescript"), 1);
var create24 = ({ factory }) => (params) => {
  const node = factory.createPropertySignature(
    params.readOnly ? [factory.createModifier(import_typescript10.default.SyntaxKind.ReadonlyKeyword)] : void 0,
    params.name,
    params.optional ? factory.createToken(import_typescript10.default.SyntaxKind.QuestionToken) : void 0,
    params.type
  );
  if (params.comment) {
    const comment = generateComment(params.comment);
    return import_typescript10.default.addSyntheticLeadingComment(node, import_typescript10.default.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
  }
  return node;
};
var make24 = (context) => {
  return {
    create: create24(context)
  };
};

// src/internal/TsGenerator/factory/RegularExpressionLiteral.ts
var create25 = ({ factory }) => (params) => {
  return factory.createRegularExpressionLiteral(params.text);
};
var make25 = (context) => {
  return {
    create: create25(context)
  };
};

// src/internal/TsGenerator/factory/ReturnStatement.ts
var create26 = ({ factory }) => (params) => {
  const node = factory.createReturnStatement(params.expression);
  return node;
};
var make26 = (context) => {
  return {
    create: create26(context)
  };
};

// src/internal/TsGenerator/factory/ShorthandPropertyAssignment.ts
var create27 = ({ factory }) => (params) => {
  const node = factory.createShorthandPropertyAssignment(params.name, void 0);
  return node;
};
var make27 = (context) => {
  return {
    create: create27(context)
  };
};

// src/internal/TsGenerator/factory/StringLiteral.ts
var create28 = ({ factory }) => (params) => {
  const node = factory.createStringLiteral(params.text, params.isSingleQuote);
  return node;
};
var make28 = (context) => {
  return {
    create: create28(context)
  };
};

// src/internal/TsGenerator/factory/TemplateExpression.ts
var create29 = ({ factory }) => (params) => {
  const node = factory.createTemplateExpression(params.head, params.templateSpans);
  return node;
};
var make29 = (context) => {
  return {
    create: create29(context)
  };
};

// src/internal/TsGenerator/factory/TemplateHead.ts
var create30 = ({ factory }) => (params) => {
  const node = factory.createTemplateHead(params.text, params.rawText, void 0);
  return node;
};
var make30 = (context) => {
  return {
    create: create30(context)
  };
};

// src/internal/TsGenerator/factory/TemplateMiddle.ts
var create31 = ({ factory }) => (params) => {
  const node = factory.createTemplateMiddle(params.text, params.rawText, void 0);
  return node;
};
var make31 = (context) => {
  return {
    create: create31(context)
  };
};

// src/internal/TsGenerator/factory/TemplateSpan.ts
var create32 = ({ factory }) => (params) => {
  const node = factory.createTemplateSpan(params.expression, params.literal);
  return node;
};
var make32 = (context) => {
  return {
    create: create32(context)
  };
};

// src/internal/TsGenerator/factory/TemplateTail.ts
var create33 = ({ factory }) => (params) => {
  const node = factory.createTemplateTail(params.text, params.rawText);
  return node;
};
var make33 = (context) => {
  return {
    create: create33(context)
  };
};

// src/internal/TsGenerator/factory/TypeAliasDeclaration.ts
var import_typescript11 = __toESM(require("typescript"), 1);
var create34 = ({ factory }) => (params) => {
  const node = factory.createTypeAliasDeclaration(
    params.export && [factory.createModifier(import_typescript11.default.SyntaxKind.ExportKeyword)],
    factory.createIdentifier(params.name),
    void 0,
    params.type
  );
  if (params.comment) {
    const comment = generateComment(params.comment, params.deprecated);
    return import_typescript11.default.addSyntheticLeadingComment(node, import_typescript11.default.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
  }
  return node;
};
var make34 = (context) => {
  return {
    create: create34(context)
  };
};

// src/internal/TsGenerator/factory/TypeLiteralNode.ts
var create35 = ({ factory }) => (params) => {
  const node = factory.createTypeLiteralNode(params.members);
  return node;
};
var make35 = (context) => {
  return {
    create: create35(context)
  };
};

// src/internal/TsGenerator/factory/TypeNode.ts
var import_typescript12 = __toESM(require("typescript"), 1);

// src/internal/TsGenerator/factory/UnionTypeNode.ts
var create36 = ({ factory }) => (params) => {
  const node = factory.createUnionTypeNode(params.typeNodes);
  return node;
};
var make36 = (context) => {
  return {
    create: create36(context)
  };
};

// src/internal/TsGenerator/factory/TypeNode.ts
var create37 = (context) => (params) => {
  const { factory } = context;
  const literalTypeNode = create15(context);
  const unionTypeNode = create36(context);
  const createNode = () => {
    switch (params.type) {
      case "string":
        if (params.enum) {
          return unionTypeNode({
            typeNodes: params.enum.map((value) => literalTypeNode({ value }))
          });
        }
        return factory.createKeywordTypeNode(import_typescript12.default.SyntaxKind.StringKeyword);
      case "number":
      case "integer":
        if (params.enum) {
          return unionTypeNode({
            typeNodes: params.enum.map((value) => literalTypeNode({ value }))
          });
        }
        return factory.createKeywordTypeNode(import_typescript12.default.SyntaxKind.NumberKeyword);
      case "boolean": {
        if (params.enum) {
          return unionTypeNode({
            typeNodes: params.enum.map((value) => literalTypeNode({ value }))
          });
        }
        return factory.createKeywordTypeNode(import_typescript12.default.SyntaxKind.BooleanKeyword);
      }
      case "object":
        return factory.createTypeLiteralNode(params.value);
      case "undefined":
        return factory.createKeywordTypeNode(import_typescript12.default.SyntaxKind.UndefinedKeyword);
      case "null":
        return factory.createLiteralTypeNode(factory.createNull());
      case "array":
        return factory.createArrayTypeNode(params.value);
      case "never":
        return factory.createKeywordTypeNode(import_typescript12.default.SyntaxKind.NeverKeyword);
      case "void":
        return factory.createKeywordTypeNode(import_typescript12.default.SyntaxKind.VoidKeyword);
      case "any":
        return factory.createKeywordTypeNode(import_typescript12.default.SyntaxKind.AnyKeyword);
      default:
        throw new UnSupportError(`UnSupport Type: ${JSON.stringify(params)}`);
    }
  };
  const node = createNode();
  return node;
};
var make37 = (context) => {
  return {
    create: create37(context)
  };
};

// src/internal/TsGenerator/factory/TypeOperatorNode.ts
var import_typescript13 = __toESM(require("typescript"), 1);
var syntaxKinds = {
  keyof: import_typescript13.default.SyntaxKind.KeyOfKeyword,
  unique: import_typescript13.default.SyntaxKind.UniqueKeyword,
  readonly: import_typescript13.default.SyntaxKind.ReadonlyKeyword
};
var create38 = ({ factory }) => (params) => {
  const node = factory.createTypeOperatorNode(syntaxKinds[params.syntaxKind], params.type);
  return node;
};
var make38 = (context) => {
  return {
    create: create38(context)
  };
};

// src/internal/TsGenerator/factory/TypeParameterDeclaration.ts
var create39 = ({ factory }) => (params) => {
  const node = factory.createTypeParameterDeclaration([], factory.createIdentifier(params.name), params.constraint, params.defaultType);
  return node;
};
var make39 = (context) => {
  return {
    create: create39(context)
  };
};

// src/internal/TsGenerator/factory/TypeReferenceNode.ts
var create40 = ({ factory }) => (params) => {
  const node = factory.createTypeReferenceNode(factory.createIdentifier(params.name), params.typeArguments);
  return node;
};
var make40 = (context) => {
  return {
    create: create40(context)
  };
};

// src/internal/TsGenerator/factory/VariableDeclaration.ts
var create41 = ({ factory }) => (params) => {
  const node = factory.createVariableDeclaration(params.name, void 0, params.type, params.initializer);
  return node;
};
var make41 = (context) => {
  return {
    create: create41(context)
  };
};

// src/internal/TsGenerator/factory/VariableDeclarationList.ts
var import_typescript14 = __toESM(require("typescript"), 1);
var flags = {
  const: import_typescript14.default.NodeFlags.Const
};
var create42 = ({ factory }) => (params) => {
  const node = factory.createVariableDeclarationList(params.declarations, flags[params.flag]);
  return node;
};
var make42 = (context) => {
  return {
    create: create42(context)
  };
};

// src/internal/TsGenerator/factory/VariableStatement.ts
var import_typescript15 = __toESM(require("typescript"), 1);
var create43 = ({ factory }) => (params) => {
  const node = factory.createVariableStatement(params.modifiers, params.declarationList);
  if (params.comment) {
    const comment = generateComment(params.comment, params.deprecated);
    return import_typescript15.default.addSyntheticLeadingComment(node, import_typescript15.default.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
  }
  return node;
};
var make43 = (context) => {
  return {
    create: create43(context)
  };
};

// src/internal/TsGenerator/factory/index.ts
var create44 = () => {
  const context = {
    factory: import_typescript16.default.factory
  };
  return {
    ArrowFunction: make(context),
    Block: make3(context),
    ClassDeclaration: make5(context),
    ParameterDeclaration: make20(context),
    InterfaceDeclaration: make13(context),
    IndexedAccessTypeNode: make12(context),
    Namespace: make17(context),
    PropertySignature: make24(context),
    PropertyDeclaration: make23(context),
    TypeAliasDeclaration: make34(context),
    TypeNode: make37(context),
    LiteralTypeNode: make15(context),
    IndexSignatureDeclaration: make11(context),
    UnionTypeNode: make36(context),
    IntersectionTypeNode: make14(context),
    TypeReferenceNode: make40(context),
    TypeParameterDeclaration: make39(context),
    TypeOperatorNode: make38(context),
    MethodDeclaration: make16(context),
    ConstructorDeclaration: make6(context),
    ReturnStatement: make26(context),
    VariableDeclaration: make41(context),
    VariableDeclarationList: make42(context),
    VariableStatement: make43(context),
    BinaryExpression: make2(context),
    PropertyAccessExpression: make21(context),
    RegularExpressionLiteral: make25(context),
    NoSubstitutionTemplateLiteral: make18(context),
    TemplateSpan: make32(context),
    TemplateExpression: make29(context),
    TemplateHead: make30(context),
    TemplateMiddle: make31(context),
    TemplateTail: make33(context),
    Identifier: make10(context),
    ShorthandPropertyAssignment: make27(context),
    PropertyAssignment: make22(context),
    ObjectLiteralExpression: make19(context),
    ElementAccessExpression: make7(context),
    ExpressionStatement: make8(context),
    CallExpression: make4(context),
    StringLiteral: make28(context),
    FunctionTypeNode: make9(context),
    TypeLiteralNode: make35(context)
  };
};

// src/internal/TsGenerator/traverse.ts
var import_typescript17 = __toESM(require("typescript"), 1);
var traverse = (create49) => (context) => (rootNode) => {
  const visit = (node) => {
    if (!import_typescript17.default.isSourceFile(node)) {
      return node;
    }
    return context.factory.updateSourceFile(
      node,
      create49(context),
      node.isDeclarationFile,
      node.referencedFiles,
      node.typeReferenceDirectives,
      node.hasNoDefaultLib,
      node.libReferenceDirectives
    );
  };
  return import_typescript17.default.visitNode(rootNode, visit);
};

// src/internal/TsGenerator/utils.ts
var utils_exports = {};
__export(utils_exports, {
  convertIntermediateCodes: () => convertIntermediateCodes,
  stringToStatements: () => stringToStatements
});
var import_typescript18 = __toESM(require("typescript"), 1);
var stringToStatements = (code) => {
  const source = import_typescript18.default.createSourceFile("", code, import_typescript18.default.ScriptTarget.ESNext, false, import_typescript18.default.ScriptKind.TS);
  return Array.from(source.statements);
};
var convertIntermediateCodes = (intermediateCodes) => {
  return intermediateCodes.reduce((result, intermediateCode) => {
    if (typeof intermediateCode === "string") {
      return [...result, ...stringToStatements(intermediateCode)];
    }
    return result.concat(intermediateCode);
  }, []);
};

// src/internal/TsGenerator/index.ts
var convertAstToTypeScriptCode = (sourceFile) => {
  const printer = import_typescript19.default.createPrinter();
  return printer.printFile(sourceFile);
};
var generate = (createFunction) => {
  const source = import_typescript19.default.createSourceFile("", "", import_typescript19.default.ScriptTarget.ESNext);
  const transformers = [traverse(createFunction)];
  const result = import_typescript19.default.transform(source, transformers);
  result.dispose();
  if (result.transformed.length > 1) {
    throw new DevelopmentError("Invalid length");
  }
  return convertAstToTypeScriptCode(result.transformed[0]);
};

// src/internal/OpenApiTools/index.ts
var OpenApiTools_exports = {};
__export(OpenApiTools_exports, {
  Comment: () => Comment_exports,
  ConvertContext: () => ConverterContext_exports,
  Parser: () => Parser
});

// src/internal/OpenApiTools/Comment.ts
var Comment_exports = {};
__export(Comment_exports, {
  generateLeading: () => generateLeading
});
var import_os2 = require("os");

// package.json
var package_default = {
  name: "@himenon/openapi-typescript-code-generator",
  version: "1.0.11",
  description: "OpenAPI Code Generator using TypeScript AST.",
  keywords: [
    "openapi",
    "openapi3",
    "openapi-codegen",
    "openapi-generator",
    "typescript",
    "typescript-ast"
  ],
  homepage: "https://github.com/Himenon/openapi-typescript-code-generator#readme",
  bugs: {
    url: "https://github.com/Himenon/openapi-typescript-code-generator/issues"
  },
  repository: {
    type: "git",
    url: "git@github.com:Himenon/openapi-typescript-code-generator.git"
  },
  license: "MIT",
  author: {
    name: "Himenon",
    email: "k.himeno314@gmail.com",
    url: "https://github.com/Himenon"
  },
  sideEffects: false,
  type: "module",
  exports: {
    ".": {
      import: "./dist/index.js",
      require: "./dist/index.cjs"
    },
    "./dist/api": {
      import: "./dist/api.js",
      require: "./dist/api.cjs"
    },
    "./dist/templates": {
      import: "./dist/templates.js",
      require: "./dist/templates.cjs"
    },
    "./dist/types": {
      import: "./dist/types.js",
      require: "./dist/types.cjs"
    },
    "./dist/meta": {
      import: "./dist/meta.js",
      require: "./dist/meta.cjs"
    }
  },
  main: "./dist/index.js",
  module: "./dist/index.js",
  browser: "./dist/index.js",
  types: "./dist/index.d.ts",
  files: [
    "dist",
    "package.json"
  ],
  scripts: {
    lint: "biome lint .",
    format: "biome format --write .",
    build: "tsup",
    clean: "pnpm ts ./scripts/clean.ts",
    "lerna:version:up": "lerna version --yes",
    "release:github:registry": "pnpm publish  --no-git-checks --registry https://npm.pkg.github.com/:_authToken=${NODE_AUTH_TOKEN}",
    "release:npm:registry": "pnpm publish --no-git-checks",
    test: "run-p test:depcruise test:jest test:code:gen:* test:snapshot",
    "test:code:gen": "run-p test:code:gen:*",
    "test:code:gen:class": "pnpm ts ./scripts/testCodeGenWithClass.ts",
    "test:code:gen:function": "pnpm ts ./scripts/testCodeGenWithFunctional.ts",
    "test:code:gen:currying-function": "pnpm ts ./scripts/testCodeGenWithCurryingFunctional.ts",
    "test:depcruise": "depcruise --validate .dependency-cruiser.cjs src",
    "test:jest": "cross-env NODE_OPTIONS=--experimental-specifier-resolution=node jest -c ./jest.config.cjs --collect-coverage",
    "test:snapshot": "jest -c ./jest.snapshot.config.cjs",
    ts: "node --no-warnings=ExperimentalWarning --experimental-specifier-resolution=node --loader ts-node/esm",
    "update:snapshot": "pnpm jest -c ./jest.snapshot.config.cjs --updateSnapshot",
    watch: "pnpm ts ./scripts/watch.ts",
    validate: "pnpm ts ./scripts/validate.ts"
  },
  "simple-git-hooks": {
    "pre-commit": "pnpm lint-staged"
  },
  "lint-staged": {
    "*.{js,jsx,json,yml,yaml,html,md,ts,tsx}": [
      "biome format --no-errors-on-unmatched --write"
    ],
    "package.json": [
      "sort-package-json"
    ]
  },
  resolutions: {
    "kind-of": "6.0.3",
    "node-fetch": "2.6.1"
  },
  dependencies: {
    "@types/json-schema": "7.0.15",
    ajv: "8.12.0",
    "js-yaml": "4.1.0"
  },
  devDependencies: {
    "@biomejs/biome": "^1.9.4",
    "@commitlint/cli": "18.6.0",
    "@commitlint/config-conventional": "18.6.0",
    "@himenon/path-oriented-data-structure": "1.0.2",
    "@swc/core": "^1.9.3",
    "@swc/helpers": "^0.5.15",
    "@swc/jest": "^0.2.37",
    "@types/chokidar": "2.1.3",
    "@types/jest": "29.5.12",
    "@types/js-yaml": "4.0.9",
    "@types/node": "20.11.16",
    "@types/rimraf": "3.0.2",
    chokidar: "3.5.3",
    "conventional-changelog-angular-all": "1.7.0",
    cpy: "11.0.0",
    "cross-env": "^7.0.3",
    "dependency-cruiser": "16.1.0",
    "dot-prop": "8.0.2",
    execa: "8.0.1",
    "generate-changelog": "1.8.0",
    "import-sort-style-module": "6.0.0",
    jest: "29.7.0",
    "jest-cli": "29.7.0",
    lerna: "8.0.2",
    "lint-staged": "15.2.1",
    "npm-run-all": "4.1.5",
    "openapi-schema-validator": "12.1.3",
    "read-package-up": "^11.0.0",
    rimraf: "5.0.5",
    "simple-git-hooks": "^2.11.1",
    "sort-package-json": "2.7.0",
    "ts-jest": "29.1.2",
    "ts-node": "10.9.2",
    tsup: "^8.3.5",
    typescript: "5.3.3"
  },
  peerDependencies: {
    typescript: ">=5"
  },
  engines: {
    pnpm: ">=9"
  },
  publishConfig: {
    access: "public"
  },
  importSort: {
    ".js, .jsx, .ts, .tsx": {
      style: "module",
      parser: "typescript"
    }
  }
};

// src/meta.ts
var Name = package_default.name;
var Version = package_default.version;

// src/internal/OpenApiTools/Comment.ts
var generateLeading = (schema) => {
  const messages = [];
  messages.push("");
  messages.push(`Generated by ${Name} v${Version}`);
  messages.push("");
  messages.push(`OpenApi : ${schema.openapi}`);
  messages.push("");
  if (schema.info.license) {
    if (schema.info.license.name) {
      messages.push(`License  : ${schema.info.license.name}`);
    }
    if (schema.info.license.url) {
      messages.push(`Url      : ${schema.info.license.url}`);
    }
  }
  messages.push("");
  return messages.map((message) => {
    return `// ${message}`;
  }).join(import_os2.EOL);
};

// src/internal/OpenApiTools/ConverterContext.ts
var ConverterContext_exports = {};
__export(ConverterContext_exports, {
  create: () => create45
});

// src/utils.ts
var parameterName = (operationId) => `Parameter$${operationId}`;
var requestBodyName = (operationId) => `RequestBody$${operationId}`;
var argumentParamsTypeDeclaration = (operationId) => `Params$${operationId}`;
var responseName = (operationId, statusCode) => `Response$${operationId}$Status$${statusCode}`;
var requestContentType = (operationId) => `RequestContentType$${operationId}`;
var responseContentType = (operationId) => `ResponseContentType$${operationId}`;
var isAvailableVariableName = (text) => {
  return /^[A-Za-z_0-9]+$/.test(text);
};
var isFirstCharacterIsValidText = (text) => {
  return /^[A-Za-z]+/.test(text);
};
var escapeText = (text) => {
  if (isAvailableVariableName(text) && isFirstCharacterIsValidText(text)) {
    return text;
  }
  return `"${text}"`;
};

// src/internal/OpenApiTools/ConverterContext.ts
var createFormatSchemaToTypeNode = (factory, target) => {
  const typeNodes = target.output.type.map((value) => {
    return factory.TypeReferenceNode.create({
      name: value
    });
  });
  if (target.output.multiType === "allOf") {
    return factory.IntersectionTypeNode.create({
      typeNodes
    });
  }
  return factory.UnionTypeNode.create({
    typeNodes
  });
};
var create45 = (factory, options) => {
  const convertReservedWord = (word) => {
    if (["import", "export"].includes(word)) {
      return `${word}_`;
    }
    return word;
  };
  const convertString = (text) => {
    if (isAvailableVariableName(text)) {
      return text;
    }
    return text.replace(/-/g, "$").replace(/\//g, "$");
  };
  const convertOperationId = (text) => {
    return convertString(text).replace(/[^a-zA-Z0-9_]/g, "$");
  };
  return {
    escapeOperationIdText: (operationId) => {
      return convertOperationId(operationId);
    },
    escapeDeclarationText: (text) => {
      return convertReservedWord(convertString(text).replace(/\./g, "$"));
    },
    escapeReferenceDeclarationText: (text) => {
      return convertReservedWord(convertString(text));
    },
    escapePropertySignatureName: (text) => {
      return escapeText(text);
    },
    escapeTypeReferenceNodeName: (text) => {
      return convertString(text);
    },
    generateResponseName: (operationId, statusCode) => {
      return responseName(convertOperationId(operationId), statusCode);
    },
    generateArgumentParamsTypeDeclaration: (operationId) => {
      return argumentParamsTypeDeclaration(convertOperationId(operationId));
    },
    generateRequestContentTypeName: (operationId) => {
      return requestContentType(convertOperationId(operationId));
    },
    generateResponseContentTypeName: (operationId) => {
      return responseContentType(convertOperationId(operationId));
    },
    generateParameterName: (operationId) => {
      return parameterName(convertOperationId(operationId));
    },
    generateRequestBodyName: (operationId) => {
      return requestBodyName(convertOperationId(operationId));
    },
    generateFunctionName: (operationId) => {
      return convertOperationId(operationId);
    },
    convertFormatTypeNode: (schema) => {
      const formatConversions = options?.formatConversions;
      if (!formatConversions || formatConversions.length === 0) {
        return;
      }
      if (typeof schema === "boolean") {
        return;
      }
      if (!schema.format) {
        return;
      }
      const target = formatConversions.find((formatConvertion) => formatConvertion.selector.format === schema.format);
      if (!target) {
        return;
      }
      return createFormatSchemaToTypeNode(factory, target);
    }
  };
};

// src/internal/OpenApiTools/Extractor.ts
var extractPickedParameter = (parameter) => {
  return {
    name: parameter.name,
    in: parameter.in,
    required: parameter.required,
    style: parameter.style,
    explode: parameter.explode
  };
};
var extractResponseNamesByStatusCode = (type, responses) => {
  const statusCodeList = [];
  for (const [statusCodeLike, response] of Object.entries(responses || {})) {
    const hasValidMediaType = Object.values(response.content || {}).filter((mediaType) => Object.values(mediaType).length > 0).length > 0;
    if (!hasValidMediaType) {
      continue;
    }
    if (typeof statusCodeLike === "string") {
      const statusCodeNumberValue = parseInt(statusCodeLike, 10);
      if (type === "success") {
        if (200 <= statusCodeNumberValue && statusCodeNumberValue < 300) {
          statusCodeList.push(statusCodeNumberValue.toString());
        }
      } else if (type === "error") {
        if (400 <= statusCodeNumberValue && statusCodeNumberValue < 600) {
          statusCodeList.push(statusCodeNumberValue.toString());
        }
      }
    }
  }
  return statusCodeList;
};
var getRequestContentTypeList = (requestBody) => {
  return Object.entries(requestBody.content).reduce((list, [key, mediaType]) => {
    const hasValidContent = Object.values(mediaType).length > 0;
    if (hasValidContent) {
      return list.concat(key);
    }
    return list;
  }, []);
};
var getSuccessResponseContentTypeList = (responses) => {
  const contentTypeList = [];
  for (const statusCode of extractResponseNamesByStatusCode("success", responses)) {
    const response = responses[statusCode];
    for (const [key, mediaType] of Object.entries(response.content || {})) {
      if (Object.values(mediaType).length > 0) {
        contentTypeList.push(key);
      }
    }
  }
  return Array.from(new Set(contentTypeList));
};
var hasQueryParameters = (parameters) => {
  if (!parameters) {
    return false;
  }
  return parameters.filter((parameter) => parameter.in === "query").length > 0;
};
var generateCodeGeneratorParamsArray = (store, converterContext, allowOperationIds) => {
  const operationState = store.getNoReferenceOperationState();
  const params = [];
  for (const [operationId, item] of Object.entries(operationState)) {
    if (allowOperationIds && !allowOperationIds.includes(operationId)) {
      continue;
    }
    const responseSuccessNames = extractResponseNamesByStatusCode("success", item.responses).map(
      (statusCode) => converterContext.generateResponseName(operationId, statusCode)
    );
    const responseErrorNames = extractResponseNamesByStatusCode("error", item.responses).map(
      (statusCode) => converterContext.generateResponseName(operationId, statusCode)
    );
    const requestContentTypeList = item.requestBody ? getRequestContentTypeList(item.requestBody) : [];
    const responseSuccessContentTypes = getSuccessResponseContentTypeList(item.responses);
    const hasOver2RequestContentTypes = requestContentTypeList.length > 1;
    const hasOver2SuccessNames = responseSuccessNames.length > 1;
    const convertedParams = {
      escapedOperationId: converterContext.escapeOperationIdText(operationId),
      argumentParamsTypeDeclaration: converterContext.generateArgumentParamsTypeDeclaration(operationId),
      functionName: converterContext.generateFunctionName(operationId),
      requestContentTypeName: converterContext.generateRequestContentTypeName(operationId),
      responseContentTypeName: converterContext.generateResponseContentTypeName(operationId),
      parameterName: converterContext.generateParameterName(operationId),
      requestBodyName: converterContext.generateRequestBodyName(operationId),
      hasRequestBody: !!item.requestBody,
      hasParameter: item.parameters ? item.parameters.length > 0 : false,
      pickedParameters: item.parameters ? item.parameters.map(extractPickedParameter) : [],
      requestContentTypes: requestContentTypeList,
      requestFirstContentType: requestContentTypeList.length === 1 ? requestContentTypeList[0] : void 0,
      responseSuccessNames,
      responseFirstSuccessName: responseSuccessNames.length === 1 ? responseSuccessNames[0] : void 0,
      has2OrMoreSuccessNames: hasOver2SuccessNames,
      responseErrorNames,
      has2OrMoreRequestContentTypes: hasOver2RequestContentTypes,
      successResponseContentTypes: responseSuccessContentTypes,
      successResponseFirstContentType: responseSuccessContentTypes.length === 1 ? responseSuccessContentTypes[0] : void 0,
      has2OrMoreSuccessResponseContentTypes: responseSuccessContentTypes.length > 1,
      hasAdditionalHeaders: hasOver2RequestContentTypes || hasOver2SuccessNames,
      hasQueryParameters: hasQueryParameters(item.parameters)
    };
    const formatParams = {
      operationId,
      convertedParams,
      operationParams: item
    };
    params.push(formatParams);
  }
  return params;
};

// src/internal/OpenApiTools/TypeNodeContext.ts
var Path = __toESM(require("path"), 1);

// node_modules/.pnpm/dot-prop@8.0.2/node_modules/dot-prop/index.js
var isObject = (value) => {
  const type = typeof value;
  return value !== null && (type === "object" || type === "function");
};
var disallowedKeys = /* @__PURE__ */ new Set([
  "__proto__",
  "prototype",
  "constructor"
]);
var digits = new Set("0123456789");
function getPathSegments(path6) {
  const parts = [];
  let currentSegment = "";
  let currentPart = "start";
  let isIgnoring = false;
  for (const character of path6) {
    switch (character) {
      case "\\": {
        if (currentPart === "index") {
          throw new Error("Invalid character in an index");
        }
        if (currentPart === "indexEnd") {
          throw new Error("Invalid character after an index");
        }
        if (isIgnoring) {
          currentSegment += character;
        }
        currentPart = "property";
        isIgnoring = !isIgnoring;
        break;
      }
      case ".": {
        if (currentPart === "index") {
          throw new Error("Invalid character in an index");
        }
        if (currentPart === "indexEnd") {
          currentPart = "property";
          break;
        }
        if (isIgnoring) {
          isIgnoring = false;
          currentSegment += character;
          break;
        }
        if (disallowedKeys.has(currentSegment)) {
          return [];
        }
        parts.push(currentSegment);
        currentSegment = "";
        currentPart = "property";
        break;
      }
      case "[": {
        if (currentPart === "index") {
          throw new Error("Invalid character in an index");
        }
        if (currentPart === "indexEnd") {
          currentPart = "index";
          break;
        }
        if (isIgnoring) {
          isIgnoring = false;
          currentSegment += character;
          break;
        }
        if (currentPart === "property") {
          if (disallowedKeys.has(currentSegment)) {
            return [];
          }
          parts.push(currentSegment);
          currentSegment = "";
        }
        currentPart = "index";
        break;
      }
      case "]": {
        if (currentPart === "index") {
          parts.push(Number.parseInt(currentSegment, 10));
          currentSegment = "";
          currentPart = "indexEnd";
          break;
        }
        if (currentPart === "indexEnd") {
          throw new Error("Invalid character after an index");
        }
      }
      default: {
        if (currentPart === "index" && !digits.has(character)) {
          throw new Error("Invalid character in an index");
        }
        if (currentPart === "indexEnd") {
          throw new Error("Invalid character after an index");
        }
        if (currentPart === "start") {
          currentPart = "property";
        }
        if (isIgnoring) {
          isIgnoring = false;
          currentSegment += "\\";
        }
        currentSegment += character;
      }
    }
  }
  if (isIgnoring) {
    currentSegment += "\\";
  }
  switch (currentPart) {
    case "property": {
      if (disallowedKeys.has(currentSegment)) {
        return [];
      }
      parts.push(currentSegment);
      break;
    }
    case "index": {
      throw new Error("Index was not closed");
    }
    case "start": {
      parts.push("");
      break;
    }
  }
  return parts;
}
function isStringIndex(object, key) {
  if (typeof key !== "number" && Array.isArray(object)) {
    const index = Number.parseInt(key, 10);
    return Number.isInteger(index) && object[index] === object[key];
  }
  return false;
}
function getProperty(object, path6, value) {
  if (!isObject(object) || typeof path6 !== "string") {
    return value === void 0 ? object : value;
  }
  const pathArray = getPathSegments(path6);
  if (pathArray.length === 0) {
    return value;
  }
  for (let index = 0; index < pathArray.length; index++) {
    const key = pathArray[index];
    if (isStringIndex(object, key)) {
      object = index === pathArray.length - 1 ? void 0 : null;
    } else {
      object = object[key];
    }
    if (object === void 0 || object === null) {
      if (index !== pathArray.length - 1) {
        return value;
      }
      break;
    }
  }
  return object === void 0 ? value : object;
}

// src/internal/OpenApiTools/TypeNodeContext.ts
var import_typescript20 = __toESM(require("typescript"), 1);

// src/internal/OpenApiTools/Guard.ts
var isReference = (data) => {
  if (typeof data !== "object" || data === null) {
    return false;
  }
  return typeof data.$ref === "string";
};
var isObjectSchema = (schema) => {
  return schema.type === "object";
};
var isHasNoMembersObject = (schema) => {
  return Object.keys(schema).length === 0;
};
var isArraySchema = (schema) => {
  return schema.type === "array";
};
var isPrimitiveSchema = (schema) => {
  if (typeof schema.type !== "string") {
    return false;
  }
  if (schema.type === "object") {
    return false;
  }
  if (schema.type === "array") {
    return false;
  }
  return true;
};
var isBooleanArray = (list) => {
  return !list.some((item) => typeof item !== "boolean");
};
var isNumberArray = (list) => {
  return !list.some((item) => typeof item !== "number");
};
var isStringArray = (list) => {
  return !list.some((item) => typeof item !== "string");
};
var isObjectSchemaWithAdditionalProperties = (schema) => {
  return !!schema.additionalProperties;
};
var isOneOfSchema = (schema) => {
  return !!schema.oneOf && typeof schema.oneOf !== "boolean" && Array.isArray(schema.oneOf);
};
var isAllOfSchema = (schema) => {
  return !!schema.allOf && typeof schema.allOf !== "boolean" && Array.isArray(schema.allOf);
};
var isAnyOfSchema = (schema) => {
  return !!schema.anyOf && typeof schema.anyOf !== "boolean" && Array.isArray(schema.anyOf);
};
var isComponentName = (name) => {
  return ["schemas", "headers", "responses", "parameters", "requestBodies", "securitySchemes", "pathItems"].includes(name);
};

// src/internal/OpenApiTools/components/Reference.ts
var import_path = require("path");

// src/internal/FileSystem/index.ts
var fs = __toESM(require("fs"), 1);
var path = __toESM(require("path"), 1);
var yaml = __toESM(require("js-yaml"), 1);
var FileSystem = class _FileSystem {
  static FRAGMENT = "#/";
  static internalLoadJsonOrYaml(filename) {
    const ext = path.extname(filename);
    const data = fs.readFileSync(filename, { encoding: "utf-8" });
    switch (ext) {
      case ".json":
        return JSON.parse(data);
      case ".yml":
      case ".yaml":
        return yaml.load(data);
      default:
        throw new UnSupportError(`Not support file: ${filename}`);
    }
  }
  static existSync(entryPoint) {
    const fragmentIndex = entryPoint.indexOf(_FileSystem.FRAGMENT);
    const hasFragment = fragmentIndex !== -1;
    if (hasFragment) {
      const filename = entryPoint.substring(0, fragmentIndex);
      return !!(fs.existsSync(filename) && fs.statSync(filename).isFile());
    }
    return !!(fs.existsSync(entryPoint) && fs.statSync(entryPoint).isFile());
  }
  static loadJsonOrYaml(entryPoint) {
    const hasFragment = entryPoint.indexOf(_FileSystem.FRAGMENT) !== -1;
    if (hasFragment) {
      const [filename, fragment] = entryPoint.split(_FileSystem.FRAGMENT);
      const data = _FileSystem.internalLoadJsonOrYaml(filename);
      return getProperty(data, fragment.replace(/\//g, "."));
    }
    return _FileSystem.internalLoadJsonOrYaml(entryPoint);
  }
};

// src/internal/Logger/index.ts
var info = (message) => {
  console.info(message);
};
var showFilePosition = (entryPoint, currentPoint, referencePoint) => {
  console.log("");
  console.log("FilePointInfo");
  console.log(`- EntryPoint     : ${entryPoint}`);
  console.log(`- CurrentPoint   : ${currentPoint}`);
  referencePoint && console.log(`- ReferencePoint : ${referencePoint}`);
  console.log("");
};
var error = (message) => {
  console.error(message);
};
var warn = (message) => {
  console.log(message);
};

// src/internal/OpenApiTools/components/Reference.ts
var localReferencePatterns = [
  "#/components/schemas/",
  "#/components/responses/",
  "#/components/parameters/",
  "#/components/examples/",
  "#/components/requestBodies/",
  "#/components/headers/",
  "#/components/securitySchemes/",
  "#/components/links/",
  "#/components/callbacks/",
  "#/components/pathItems/"
];
var localReferenceComponents = {
  "#/components/schemas/": "components/schemas",
  "#/components/responses/": "components/responses",
  "#/components/parameters/": "components/parameters",
  "#/components/examples/": "components/examples",
  "#/components/requestBodies/": "components/requestBodies",
  "#/components/headers/": "components/headers",
  "#/components/securitySchemes/": "components/securitySchemes",
  "#/components/links/": "components/links",
  "#/components/callbacks/": "components/callbacks",
  "#/components/pathItems/": "components/pathItems"
};
var getLocalReferencePattern = (reference) => {
  let localReferencePattern;
  localReferencePatterns.forEach((referencePattern) => {
    if (new RegExp(`^${referencePattern}`).test(reference.$ref)) {
      localReferencePattern = referencePattern;
    }
  });
  return localReferencePattern;
};
var generateLocalReference = (reference) => {
  const localReferencePattern = getLocalReferencePattern(reference);
  if (!localReferencePattern) {
    return;
  }
  const name = reference.$ref.split(localReferencePattern)[1];
  const localPath = import_path.posix.posix.join(localReferenceComponents[localReferencePattern], name);
  if (!localPath.startsWith("components")) {
    throw new DevelopmentError(`localPath is not start "components":
${localPath}`);
  }
  return {
    type: "local",
    name,
    path: localPath
  };
};
var generateReferencePoint = (currentPoint, reference) => {
  const basedir = import_path.posix.dirname(currentPoint);
  const ref = reference.$ref;
  const referencePoint = import_path.posix.join(basedir, ref);
  return referencePoint;
};
var generate2 = (entryPoint, currentPoint, reference) => {
  const localReference = generateLocalReference(reference);
  if (localReference) {
    return localReference;
  }
  if (reference.$ref.startsWith("http")) {
    throw new FeatureDevelopmentError("Please Pull Request ! Welcome !");
  }
  const referencePoint = generateReferencePoint(currentPoint, reference);
  if (!FileSystem.existSync(referencePoint)) {
    showFilePosition(entryPoint, currentPoint, referencePoint);
    error(JSON.stringify(reference, null, 2));
    throw new NotFoundFileError(`Not found reference point from current point. 
 Path: ${referencePoint}`);
  }
  const fragmentIndex = referencePoint.indexOf("#/");
  let targetPath;
  if (fragmentIndex !== -1) {
    targetPath = referencePoint.substring(fragmentIndex + 2);
  } else {
    const relativePathFromEntryPoint = import_path.posix.relative(import_path.posix.dirname(entryPoint), referencePoint);
    const pathArray2 = relativePathFromEntryPoint.split(import_path.posix.sep);
    if (pathArray2[0] !== "components") {
      throw new DevelopmentError(`targetPath is not start "components":
${relativePathFromEntryPoint}`);
    }
    const ext = import_path.posix.extname(relativePathFromEntryPoint);
    targetPath = pathArray2.join("/").substring(0, relativePathFromEntryPoint.length - ext.length);
  }
  const pathArray = targetPath.split("/");
  const schemaName = pathArray[pathArray.length - 1];
  const componentName = pathArray[0] === "components" ? pathArray[1] : "";
  const data = FileSystem.loadJsonOrYaml(referencePoint);
  if (isReference(data)) {
    return generate2(entryPoint, referencePoint, data);
  }
  return {
    type: "remote",
    referencePoint,
    path: targetPath,
    name: schemaName,
    componentName: isComponentName(componentName) ? componentName : void 0,
    data
  };
};
var resolveRemoteReference = (entryPoint, currentPoint, reference) => {
  if (reference.$ref.startsWith("#") || reference.$ref.startsWith("http")) {
    return { referencePoint: currentPoint, data: reference };
  }
  const referencePoint = generateReferencePoint(currentPoint, reference);
  if (!FileSystem.existSync(referencePoint)) {
    showFilePosition(entryPoint, currentPoint, referencePoint);
    error(JSON.stringify(reference, null, 2));
    throw new NotFoundFileError(`Not found reference point from current point. 
 Path: ${referencePoint}`);
  }
  const data = FileSystem.loadJsonOrYaml(referencePoint);
  if (isReference(data)) {
    return resolveRemoteReference(entryPoint, referencePoint, data);
  }
  return {
    referencePoint,
    data
  };
};

// src/internal/OpenApiTools/InferredType.ts
var getInferredType = (schema) => {
  if (schema.type || schema.oneOf || schema.allOf || schema.anyOf) {
    return schema;
  }
  if (schema.items) {
    return { ...schema, type: "array" };
  }
  if (schema.enum) {
    return { ...schema, type: "string" };
  }
  if (schema.properties) {
    return { ...schema, type: "object" };
  }
  if (schema.required) {
    const properties = schema.required.reduce((s, name) => {
      return { ...s, [name]: { type: "any" } };
    }, {});
    return { ...schema, type: "object", properties };
  }
  return void 0;
};

// src/internal/OpenApiTools/toTypeNode.ts
var generateMultiTypeNode = (entryPoint, currentPoint, factory, schemas, setReference, convert2, convertContext, multiType) => {
  const typeNodes = schemas.map((schema) => convert2(entryPoint, currentPoint, factory, schema, setReference, convertContext));
  if (multiType === "oneOf") {
    return factory.UnionTypeNode.create({
      typeNodes
    });
  }
  if (multiType === "allOf") {
    return factory.IntersectionTypeNode.create({
      typeNodes
    });
  }
  return factory.UnionTypeNode.create({
    typeNodes
  });
};
var nullable = (factory, typeNode, nullable3) => {
  if (nullable3) {
    return factory.UnionTypeNode.create({
      typeNodes: [
        typeNode,
        factory.TypeNode.create({
          type: "null"
        })
      ]
    });
  }
  return typeNode;
};
var convert = (entryPoint, currentPoint, factory, schema, context, converterContext, option) => {
  if (typeof schema === "boolean") {
    return factory.TypeNode.create({
      type: "object",
      value: []
    });
  }
  if (isReference(schema)) {
    const reference = generate2(entryPoint, currentPoint, schema);
    if (reference.type === "local") {
      context.setReferenceHandler(currentPoint, reference);
      const { maybeResolvedName, depth, pathArray } = context.resolveReferencePath(currentPoint, reference.path);
      if (depth === 2) {
        return factory.TypeReferenceNode.create({ name: converterContext.escapeReferenceDeclarationText(maybeResolvedName) });
      }
      const resolveSchema = context.findSchemaByPathArray(pathArray);
      return convert(entryPoint, currentPoint, factory, resolveSchema, context, converterContext, { parent: schema });
    }
    if (reference.componentName) {
      context.setReferenceHandler(currentPoint, reference);
      return factory.TypeReferenceNode.create({ name: context.resolveReferencePath(currentPoint, reference.path).name });
    }
    return convert(entryPoint, reference.referencePoint, factory, reference.data, context, converterContext, { parent: schema });
  }
  if (isOneOfSchema(schema)) {
    return nullable(
      factory,
      generateMultiTypeNode(entryPoint, currentPoint, factory, schema.oneOf, context, convert, converterContext, "oneOf"),
      !!schema.nullable
    );
  }
  if (isAllOfSchema(schema)) {
    return nullable(
      factory,
      generateMultiTypeNode(entryPoint, currentPoint, factory, schema.allOf, context, convert, converterContext, "allOf"),
      !!schema.nullable
    );
  }
  if (isAnyOfSchema(schema)) {
    return nullable(
      factory,
      generateMultiTypeNode(entryPoint, currentPoint, factory, schema.anyOf, context, convert, converterContext, "anyOf"),
      !!schema.nullable
    );
  }
  if (isHasNoMembersObject(schema)) {
    return factory.TypeNode.create({
      type: "object",
      value: []
    });
  }
  if (!schema.type) {
    const inferredSchema = getInferredType(schema);
    if (inferredSchema) {
      return convert(entryPoint, currentPoint, factory, inferredSchema, context, converterContext, { parent: schema });
    }
    if (typeof schema.nullable === "boolean") {
      const typeNode2 = factory.TypeNode.create({
        type: "any"
      });
      return nullable(factory, typeNode2, schema.nullable);
    }
    if (option?.parent) {
      const message = [
        "Schema Type is not found and is converted to the type any. The parent Schema is as follows.",
        "",
        JSON.stringify(option.parent),
        ""
      ].join("\n");
      info(message);
    }
    const typeNode = factory.TypeNode.create({
      type: "any"
    });
    return typeNode;
  }
  switch (schema.type) {
    case "boolean": {
      const items = schema.enum;
      let typeNode;
      if (items && isBooleanArray(items)) {
        typeNode = factory.TypeNode.create({
          type: schema.type,
          enum: items
        });
      } else {
        typeNode = factory.TypeNode.create({
          type: schema.type
        });
      }
      return nullable(factory, typeNode, !!schema.nullable);
    }
    case "null": {
      return factory.TypeNode.create({
        type: schema.type
      });
    }
    case "integer":
    case "number": {
      const items = schema.enum;
      let typeNode;
      const formatTypeNode = converterContext.convertFormatTypeNode(schema);
      if (formatTypeNode) {
        return formatTypeNode;
      }
      if (items && isNumberArray(items)) {
        typeNode = factory.TypeNode.create({
          type: schema.type,
          enum: items
        });
      } else {
        typeNode = factory.TypeNode.create({
          type: schema.type
        });
      }
      return nullable(factory, typeNode, !!schema.nullable);
    }
    case "string": {
      const items = schema.enum;
      const formatTypeNode = converterContext.convertFormatTypeNode(schema);
      if (formatTypeNode) {
        return formatTypeNode;
      }
      let typeNode;
      if (items && isStringArray(items)) {
        typeNode = factory.TypeNode.create({
          type: schema.type,
          enum: items
        });
      } else {
        typeNode = factory.TypeNode.create({
          type: schema.type
        });
      }
      return nullable(factory, typeNode, !!schema.nullable);
    }
    case "array": {
      if (Array.isArray(schema.items) || typeof schema.items === "boolean") {
        throw new UnSupportError(`schema.items = ${JSON.stringify(schema.items)}`);
      }
      const typeNode = factory.TypeNode.create({
        type: schema.type,
        value: schema.items ? convert(entryPoint, currentPoint, factory, schema.items, context, converterContext, { parent: schema }) : factory.TypeNode.create({
          type: "undefined"
        })
      });
      return nullable(factory, typeNode, !!schema.nullable);
    }
    case "object": {
      const required = schema.required || [];
      if (schema.additionalProperties === true) {
        return factory.TypeNode.create({
          type: schema.type,
          value: []
        });
      }
      const value = Object.entries(schema.properties || {}).map(([name, jsonSchema]) => {
        return factory.PropertySignature.create({
          readOnly: typeof jsonSchema !== "boolean" ? !!jsonSchema.readOnly : false,
          name: converterContext.escapePropertySignatureName(name),
          type: convert(entryPoint, currentPoint, factory, jsonSchema, context, converterContext, { parent: schema.properties }),
          optional: !required.includes(name),
          comment: typeof jsonSchema !== "boolean" ? jsonSchema.description : void 0
        });
      });
      if (schema.additionalProperties) {
        const additionalProperties = factory.IndexSignatureDeclaration.create({
          name: "key",
          type: convert(entryPoint, currentPoint, factory, schema.additionalProperties, context, converterContext, {
            parent: schema.properties
          })
        });
        const hasOptionalProperty = Object.keys(schema.properties || {}).some((key) => !required.includes(key));
        if (hasOptionalProperty) {
          const objectTypeNode = factory.TypeNode.create({
            type: schema.type,
            value
          });
          const additionalObjectTypeNode = factory.TypeNode.create({
            type: schema.type,
            value: [additionalProperties]
          });
          return factory.IntersectionTypeNode.create({
            typeNodes: [objectTypeNode, additionalObjectTypeNode]
          });
        }
        return factory.TypeNode.create({
          type: schema.type,
          value: [...value, additionalProperties]
        });
      }
      const typeNode = factory.TypeNode.create({
        type: schema.type,
        value
      });
      return nullable(factory, typeNode, !!schema.nullable);
    }
    default:
      return factory.TypeNode.create({
        type: "any"
      });
  }
};
var convertAdditionalProperties = (entryPoint, currentPoint, factory, schema, setReference, convertContext) => {
  if (schema.additionalProperties === true) {
    factory.TypeNode.create({
      type: schema.type,
      value: []
    });
  }
  const additionalProperties = factory.IndexSignatureDeclaration.create({
    name: "key",
    type: convert(entryPoint, currentPoint, factory, schema.additionalProperties, setReference, convertContext, {
      parent: schema.properties
    })
  });
  return additionalProperties;
};

// src/internal/OpenApiTools/TypeNodeContext.ts
var generatePath = (entryPoint, currentPoint, referencePath) => {
  const ext = Path.extname(currentPoint);
  const from = Path.relative(Path.dirname(entryPoint), currentPoint).replace(ext, "");
  const base = Path.dirname(from).replace(Path.sep, "/");
  const result = Path.posix.relative(base, referencePath);
  const pathArray = result.split("/");
  return {
    pathArray,
    base
  };
};
var calculateReferencePath = (store, base, pathArray, converterContext) => {
  let names = [];
  let unresolvedPaths = [];
  pathArray.reduce((previous, lastPath, index) => {
    const current = Path.posix.join(previous, lastPath);
    if (lastPath === ".." && names.length > 0) {
      names = names.slice(0, names.length - 1);
    }
    const isFinalPath = index === pathArray.length - 1;
    if (isFinalPath) {
      const statement = store.getStatement(current, "interface");
      const statement2 = store.getStatement(current, "typeAlias");
      const statement3 = store.getStatement(current, "namespace");
      if (statement) {
        names.push(statement.name);
        return current;
      }
      if (statement2) {
        names.push(statement2.name);
        return current;
      }
      if (statement3) {
        names.push(statement3.name);
        return current;
      }
      unresolvedPaths.push(lastPath);
    } else {
      const statement = store.getStatement(current, "namespace");
      if (statement) {
        unresolvedPaths = unresolvedPaths.slice(0, unresolvedPaths.length - 1);
        names.push(statement.name);
      } else {
        unresolvedPaths.push(lastPath);
      }
    }
    return current;
  }, base);
  if (names.length === 0) {
    throw new DevelopmentError(`Local Reference Error 
${JSON.stringify({ pathArray, names, base }, null, 2)}`);
  }
  const maybeResolvedNameFragments = names.concat(unresolvedPaths).map(converterContext.escapeDeclarationText);
  return {
    name: names.map(converterContext.escapeDeclarationText).join("."),
    maybeResolvedName: maybeResolvedNameFragments.join("."),
    unresolvedPaths,
    depth: maybeResolvedNameFragments.length,
    pathArray
  };
};
var create46 = (entryPoint, rootSchema, store, factory, converterContext) => {
  const resolveReferencePath = (currentPoint, referencePath) => {
    const { pathArray, base } = generatePath(entryPoint, currentPoint, referencePath);
    return calculateReferencePath(store, base, pathArray, converterContext);
  };
  const findSchemaByPathArray = (pathArray, remainPathArray = []) => {
    const schema = getProperty(rootSchema, pathArray.join("."));
    if (!schema) {
      return findSchemaByPathArray(pathArray.slice(0, pathArray.length - 1), [pathArray[pathArray.length - 1], ...remainPathArray]);
    }
    if (isReference(schema)) {
      const ref = generate2(entryPoint, entryPoint, schema);
      return findSchemaByPathArray(ref.path.split("/"), remainPathArray);
    }
    if (remainPathArray.length) {
      const moreNestSchema = getProperty(schema, remainPathArray.join("."));
      if (!moreNestSchema) {
        throw new Error("Not found");
      }
      return moreNestSchema;
    }
    return schema;
  };
  const setReferenceHandler = (currentPoint, reference) => {
    if (store.hasStatement(reference.path, ["interface", "typeAlias"])) {
      return;
    }
    if (reference.type === "remote") {
      const typeNode = convert(
        entryPoint,
        reference.referencePoint,
        factory,
        reference.data,
        {
          rootSchema,
          setReferenceHandler,
          resolveReferencePath,
          findSchemaByPathArray
        },
        converterContext
      );
      if (import_typescript20.default.isTypeLiteralNode(typeNode)) {
        store.addStatement(reference.path, {
          kind: "interface",
          name: reference.name,
          value: factory.InterfaceDeclaration.create({
            export: true,
            name: reference.name,
            members: typeNode.members
          })
        });
      } else {
        const value = factory.TypeAliasDeclaration.create({
          export: true,
          name: converterContext.escapeDeclarationText(reference.name),
          type: convert(
            entryPoint,
            reference.referencePoint,
            factory,
            reference.data,
            {
              rootSchema,
              setReferenceHandler,
              resolveReferencePath,
              findSchemaByPathArray
            },
            converterContext
          )
        });
        store.addStatement(reference.path, {
          name: reference.name,
          kind: "typeAlias",
          value
        });
      }
    } else if (reference.type === "local") {
      if (!store.isAfterDefined(reference.path)) {
        const { maybeResolvedName } = resolveReferencePath(currentPoint, reference.path);
        const value = factory.TypeAliasDeclaration.create({
          export: true,
          name: converterContext.escapeDeclarationText(reference.name),
          type: factory.TypeReferenceNode.create({
            name: converterContext.escapeTypeReferenceNodeName(maybeResolvedName)
          })
        });
        store.addStatement(reference.path, {
          name: reference.name,
          kind: "typeAlias",
          value
        });
      }
    }
  };
  return {
    rootSchema,
    setReferenceHandler,
    resolveReferencePath,
    findSchemaByPathArray
  };
};

// src/internal/OpenApiTools/Walker/Store.ts
var Path2 = __toESM(require("path"), 1);

// node_modules/.pnpm/@himenon+path-oriented-data-structure@1.0.2/node_modules/@himenon/path-oriented-data-structure/dist/chunk-DIWYDXPL.js
var Node = class {
  constructor(kind, name) {
    this.kind = kind;
    this.name = name;
  }
  getChildren() {
    return void 0;
  }
  hasChildren() {
    return false;
  }
  getHierarchy() {
    return {
      name: this.name
    };
  }
  getChildByPaths() {
    return void 0;
  }
  set() {
    return;
  }
  remove() {
    return;
  }
};

// node_modules/.pnpm/@himenon+path-oriented-data-structure@1.0.2/node_modules/@himenon/path-oriented-data-structure/dist/chunk-CSAU5B4Q.js
var __defProp2 = Object.defineProperty;
var __export2 = (target, all) => {
  for (var name in all)
    __defProp2(target, name, { get: all[name], enumerable: true });
};

// node_modules/.pnpm/@himenon+path-oriented-data-structure@1.0.2/node_modules/@himenon/path-oriented-data-structure/dist/chunk-4ENVCU5M.js
var Utils_exports = {};
__export2(Utils_exports, {
  generateKey: () => generateKey,
  split: () => split,
  splitKey: () => splitKey
});
var generateKey = (kind, name) => {
  return `${kind}:${name}`;
};
var splitKey = (key) => {
  return key.split(":");
};
var split = (p, delimiter) => {
  const array = [];
  for (const seg of p.split(delimiter)) {
    switch (seg) {
      case ".":
        break;
      case "..":
        array.pop();
        break;
      default:
        array.push(seg);
        break;
    }
  }
  return array;
};

// node_modules/.pnpm/@himenon+path-oriented-data-structure@1.0.2/node_modules/@himenon/path-oriented-data-structure/dist/chunk-B3QRDH5K.js
var Tree = class {
  constructor(kind, name) {
    this.kind = kind;
    this.name = name;
  }
  children = {};
  getChildByPaths(paths, kind) {
    const [name, ...pathArray] = paths;
    if (!name) {
      return;
    }
    if (pathArray.length === 0) {
      const component = this.children[generateKey(kind, name)];
      return component;
    }
    const childTree = this.children[generateKey(this.kind, name)];
    return childTree && childTree.getChildByPaths(pathArray, kind);
  }
  getHierarchy() {
    const entires = Object.entries(this.children).map(([key, child]) => {
      return [key, child.getHierarchy()];
    });
    return {
      name: this.name,
      children: Object.fromEntries(entires)
    };
  }
  getChildren() {
    return this.children;
  }
  hasChildren() {
    return Object.keys(this.children).length === 0;
  }
  set(pathName, component) {
    const key = generateKey(component.kind, pathName);
    this.children[key] = component;
  }
  remove(pathName, component) {
    const targetKey = generateKey(component.kind, pathName);
    const entries = Object.entries(this.children).filter(([key]) => {
      return targetKey !== key;
    });
    this.children = Object.fromEntries(entries);
  }
};

// node_modules/.pnpm/@himenon+path-oriented-data-structure@1.0.2/node_modules/@himenon/path-oriented-data-structure/dist/chunk-FR6AL2AE.js
var Operator = class {
  constructor(treeKind, delimiter = "/") {
    this.treeKind = treeKind;
    this.delimiter = delimiter;
    this.tree = new Tree(treeKind, ".");
  }
  tree;
  setToRootOrParent(component, currentPathName, previousPathArray, nextPathArray) {
    const childComponent = this.tree.getChildByPaths(nextPathArray, component.kind);
    if (childComponent || nextPathArray.length === 0) {
      return;
    }
    if (previousPathArray.length === 0 && nextPathArray.length === 1) {
      this.tree.set(nextPathArray[0], component);
    } else {
      const parentComponent = this.tree.getChildByPaths(previousPathArray, this.treeKind);
      parentComponent && parentComponent.set(currentPathName, component);
    }
  }
  removeFromRootOrParent(currentPathName, currentPathArray, component) {
    const previousPathArray = currentPathArray.slice(0, currentPathArray.length - 1);
    if (previousPathArray.length === 0 && currentPathArray.length === 1) {
      this.tree.remove(currentPathName, component);
    } else {
      const parentComponent = this.tree.getChildByPaths(previousPathArray, this.treeKind);
      parentComponent && parentComponent.remove(currentPathName, component);
    }
  }
  getHierarchy() {
    return this.tree.getHierarchy();
  }
  getChildByPaths(path6, kind) {
    const pathArray = split(path6, this.delimiter);
    return this.tree.getChildByPaths(pathArray, kind);
  }
  set(path6, component) {
    const pathArray = split(path6, this.delimiter);
    const pathArrayLength = pathArray.length;
    pathArray.reduce((previousPathArray, currentPathName, currentIndex) => {
      const nextPathArray = previousPathArray.concat(currentPathName);
      const isLastIndex = currentIndex === pathArrayLength - 1;
      if (isLastIndex) {
        this.setToRootOrParent(component, currentPathName, previousPathArray, nextPathArray);
      } else {
        const tree = new Tree(this.treeKind, currentPathName);
        this.setToRootOrParent(tree, currentPathName, previousPathArray, nextPathArray);
      }
      return nextPathArray;
    }, []);
  }
  remove(path6, kind) {
    const pathArray = split(path6, this.delimiter);
    const pathArrayLength = pathArray.length;
    for (let i = 0; i <= pathArrayLength; i++) {
      const currentPathArray = pathArray.slice(0, pathArrayLength - i);
      const currentPathName = pathArray[pathArrayLength - i - 1];
      if (!currentPathName) {
        continue;
      }
      if (i === 0) {
        const component = this.tree.getChildByPaths(currentPathArray, kind);
        component && this.removeFromRootOrParent(currentPathName, currentPathArray, component);
      } else {
        const component = this.tree.getChildByPaths(currentPathArray, this.treeKind);
        component && component.hasChildren() && this.removeFromRootOrParent(currentPathName, currentPathArray, component);
      }
    }
  }
  copy(from, to, kind) {
    const fromComponent = this.getChildByPaths(from, kind);
    const toComponent = this.getChildByPaths(to, kind);
    if (toComponent || !fromComponent) {
      return false;
    }
    this.set(to, fromComponent);
    return true;
  }
  move(from, to, kind) {
    const success = this.copy(from, to, kind);
    if (success) {
      this.remove(from, kind);
      return true;
    }
    return false;
  }
  getChildPaths(kind, children, parentPath) {
    let pathArray = [];
    Object.entries(children).forEach(([key, child]) => {
      const subChildren = child.getChildren();
      const [, pathName] = splitKey(key);
      const nextPath = [parentPath, pathName].join(this.delimiter).replace(/\/$/, "");
      if (subChildren) {
        pathArray = pathArray.concat(this.getChildPaths(kind, subChildren, nextPath));
      } else if (child.kind === kind) {
        pathArray.push(nextPath);
      }
    });
    return pathArray;
  }
  getNodePaths(kind) {
    return this.getChildPaths(kind, this.tree.getChildren(), this.tree.name);
  }
};

// src/internal/OpenApiTools/Walker/Definition.ts
var componentNames = [
  "schemas",
  "headers",
  "responses",
  "parameters",
  "requestBodies",
  "securitySchemes",
  "pathItems"
];

// src/internal/OpenApiTools/Walker/Operation.ts
var import_os3 = require("os");
var httpMethodList = ["get", "put", "post", "delete", "options", "head", "patch", "trace"];
var uniqParameters = (rawParameters) => {
  const parameterMap = rawParameters.reduce((all, parameter) => {
    return { ...all, [`${parameter.in}:${parameter.name}`]: parameter };
  }, {});
  return Object.values(parameterMap);
};
var create47 = (rootSchema) => {
  const paths = rootSchema.paths || {};
  const state = {};
  Object.entries(paths).forEach(([requestUri, pathItem]) => {
    httpMethodList.forEach((httpMethod) => {
      const operation = pathItem[httpMethod];
      if (!operation) {
        return;
      }
      if (!operation.operationId) {
        return;
      }
      const parameters = [...pathItem.parameters || [], ...operation.parameters || []];
      const requestBody = operation.requestBody;
      const hasValidMediaType = Object.values(requestBody?.content || {}).filter((mediaType) => Object.values(mediaType).length > 0).length > 0;
      state[operation.operationId] = {
        httpMethod,
        requestUri,
        comment: [operation.summary, operation.description].filter(Boolean).join(import_os3.EOL),
        deprecated: !!operation.deprecated,
        requestBody: hasValidMediaType ? requestBody : void 0,
        parameters: uniqParameters(parameters),
        responses: operation.responses
      };
    });
  });
  return state;
};

// src/internal/OpenApiTools/Walker/State.ts
var createDefaultOperationState = (httpMethod, requestUri, state) => {
  return {
    httpMethod,
    requestUri,
    parameterName: state.parameterName,
    requestBodyName: state.parameterName
  };
};
var createDefaultState = (rootDocument) => ({
  document: rootDocument,
  additionalStatements: [],
  operations: {}
});

// src/internal/OpenApiTools/Walker/structure/InterfaceNode.ts
var InterfaceNode_exports = {};
__export(InterfaceNode_exports, {
  Item: () => Item
});
var Item = class extends Node {
  value;
  constructor(params) {
    super("interface", params.name);
    this.value = params.value;
  }
};

// src/internal/OpenApiTools/Walker/structure/NamespaceTree.ts
var NamespaceTree_exports = {};
__export(NamespaceTree_exports, {
  Item: () => Item2
});
var Item2 = class extends Tree {
  constructor(params) {
    super("namespace", params.name);
    this.params = params;
  }
};

// src/internal/OpenApiTools/Walker/structure/TypeAliasNode.ts
var TypeAliasNode_exports = {};
__export(TypeAliasNode_exports, {
  Item: () => Item3
});
var Item3 = class extends Node {
  value;
  constructor(params) {
    super("typeAlias", params.name);
    this.value = params.value;
  }
};

// src/internal/OpenApiTools/Walker/structure/DataStructure.ts
var createGetChildByPaths = (operator) => (path6, kind) => {
  return operator.getChildByPaths(path6, kind);
};

// src/internal/OpenApiTools/Walker/structure/index.ts
var createInstance = (component) => {
  if (component.kind === "interface") {
    return new Item(component);
  }
  if (component.kind === "typeAlias") {
    return new Item3(component);
  }
  if (component.kind === "namespace") {
    return new Item2(component);
  }
  throw new Error("not registers");
};
var create48 = () => {
  const operator = new Operator("namespace");
  return {
    operator,
    getChildByPaths: createGetChildByPaths(operator)
  };
};

// src/internal/OpenApiTools/Walker/Store.ts
var Store = class {
  constructor(factory, rootDocument) {
    this.factory = factory;
    this.state = createDefaultState(rootDocument);
    const { operator, getChildByPaths } = create48();
    this.operator = operator;
    this.getChildByPaths = getChildByPaths;
  }
  state;
  operator;
  getChildByPaths;
  convertNamespace(tree) {
    const statements = [];
    Object.values(tree.getChildren()).map((child) => {
      if (child instanceof Tree || child instanceof NamespaceTree_exports.Item) {
        statements.push(this.convertNamespace(child));
      } else if (child instanceof InterfaceNode_exports.Item) {
        statements.push(child.value);
      } else if (child instanceof TypeAliasNode_exports.Item) {
        statements.push(child.value);
      }
    });
    if (tree instanceof NamespaceTree_exports.Item) {
      return this.factory.Namespace.create({
        export: true,
        name: tree.params.name,
        statements,
        comment: tree.params.comment,
        deprecated: tree.params.deprecated
      });
    }
    return this.factory.Namespace.create({
      export: true,
      name: tree.name,
      statements
    });
  }
  capitalizeFirstLetter(text) {
    return text.charAt(0).toUpperCase() + text.slice(1);
  }
  getRootStatements() {
    const statements = componentNames.reduce((statements2, componentName) => {
      const treeOfNamespace = this.getChildByPaths(componentName, "namespace");
      if (treeOfNamespace) {
        treeOfNamespace.name = this.capitalizeFirstLetter(treeOfNamespace.name);
        return statements2.concat(this.convertNamespace(treeOfNamespace));
      }
      return statements2;
    }, []);
    return statements;
  }
  getAdditionalStatements() {
    return this.state.additionalStatements;
  }
  /**
   * @params path: "components/headers/hoge"
   */
  hasStatement(path6, types) {
    const alreadyRegistered = types.some((type) => !!this.operator.getChildByPaths(path6, type));
    return alreadyRegistered;
  }
  /**
   * @params path: "components/headers/hoge"
   */
  addStatement(path6, statement, options) {
    if (!path6.startsWith("components")) {
      throw new UnSupportError(`components\u304B\u3089\u59CB\u307E\u3063\u3066\u3044\u307E\u305B\u3093\u3002path=${path6}`);
    }
    const targetPath = Path2.posix.relative("components", path6);
    if (this.hasStatement(targetPath, ["interface", "namespace"])) {
      return;
    }
    if (!!options?.override || this.hasStatement(targetPath, ["typeAlias"]) && statement.kind === "interface") {
      this.operator.remove(targetPath, "typeAlias");
    }
    this.operator.set(targetPath, createInstance(statement));
  }
  getStatement(path6, kind) {
    const targetPath = Path2.posix.relative("components", path6);
    if (path6.split("/").length === 2 && kind === "namespace") {
      const child = this.getChildByPaths(targetPath, kind);
      if (child) {
        child.name = this.capitalizeFirstLetter(child.name);
      }
      return child;
    }
    return this.getChildByPaths(targetPath, kind);
  }
  addComponent(componentName, statement) {
    this.operator.set(`${componentName}`, createInstance(statement));
  }
  getNoReferenceOperationState() {
    return create47(this.state.document);
  }
  updateOperationState(httpMethod, requestUri, operationId, newOperationState) {
    let operationState = this.state.operations[operationId];
    if (operationState) {
      operationState = { ...operationState, ...newOperationState };
    } else {
      operationState = createDefaultOperationState(httpMethod, requestUri, newOperationState);
    }
    this.state.operations[operationId] = operationState;
  }
  addAdditionalStatement(statements) {
    this.state.additionalStatements = this.state.additionalStatements.concat(statements);
  }
  getPathItem(localPath) {
    if (!localPath.startsWith("components/pathItem")) {
      throw new Error(`Only use start with 'component/pathItems': ${localPath}`);
    }
    const result = getProperty(this.state.document, localPath.replace(/\//g, "."));
    if (!result) {
      throw new Error(`Not found ${localPath}`);
    }
    return result;
  }
  getParameter(localPath) {
    if (!localPath.startsWith("components/parameters")) {
      throw new Error(`Only use start with 'component/parameters': ${localPath}`);
    }
    const result = getProperty(this.state.document, localPath.replace(/\//g, "."));
    if (!result) {
      throw new Error(`Not found ${localPath}`);
    }
    return result;
  }
  isAfterDefined(referencePath) {
    return !!getProperty(this.state.document, referencePath.replace(/\//g, "."));
  }
};

// src/internal/OpenApiTools/Name.ts
var Components = {
  Schemas: "Schemas",
  Parameters: "Parameters",
  Headers: "Headers",
  SecuritySchemas: "SecuritySchemas",
  PathItems: "PathItems",
  RequestBodies: "RequestBodies",
  Responses: "Responses"
};
var ComponentChild = {
  Header: "Header",
  Content: "Content",
  Response: "Response"
};

// src/internal/OpenApiTools/components/Header.ts
var generateTypeNode = (entryPoint, currentPoint, factory, name, header, context, converterContext) => {
  return factory.TypeAliasDeclaration.create({
    export: true,
    name: converterContext.escapeDeclarationText(name),
    type: convert(entryPoint, currentPoint, factory, header.schema || { type: "null" }, context, converterContext)
  });
};
var generatePropertySignature = (entryPoint, currentPoint, factory, name, header, context, converterContext) => {
  if (isReference(header)) {
    const reference = generate2(entryPoint, currentPoint, header);
    if (reference.type === "local") {
      context.setReferenceHandler(currentPoint, reference);
      return factory.PropertySignature.create({
        readOnly: false,
        name: converterContext.escapePropertySignatureName(name),
        optional: false,
        type: factory.TypeReferenceNode.create({
          name: context.resolveReferencePath(currentPoint, reference.path).name
        })
      });
    }
    return factory.PropertySignature.create({
      readOnly: false,
      name: converterContext.escapePropertySignatureName(name),
      optional: false,
      type: factory.TypeReferenceNode.create({
        name: context.resolveReferencePath(currentPoint, reference.path).name
      })
    });
  }
  return factory.PropertySignature.create({
    readOnly: false,
    name: converterContext.escapePropertySignatureName(name),
    optional: false,
    type: convert(entryPoint, currentPoint, factory, header.schema || { type: "null" }, context, converterContext)
  });
};
var generatePropertySignatures = (entryPoint, currentPoint, factory, headers, context, converterContext) => {
  return Object.entries(headers).map(([headerName, header]) => {
    return generatePropertySignature(entryPoint, currentPoint, factory, headerName, header, context, converterContext);
  });
};
var generateInterface = (entryPoint, currentPoint, factory, name, headers, context, converterContext) => {
  return factory.InterfaceDeclaration.create({
    export: true,
    name: converterContext.escapeDeclarationText(name),
    members: generatePropertySignatures(entryPoint, currentPoint, factory, headers, context, converterContext)
  });
};

// src/internal/OpenApiTools/components/ExternalDocumentation.ts
var import_os4 = require("os");
var addComment = (comment, externalDocs) => {
  if (!externalDocs) {
    return comment;
  }
  return [comment, "", `@see ${externalDocs.url}`, externalDocs.description].filter(Boolean).join(import_os4.EOL);
};

// src/internal/OpenApiTools/components/Schema.ts
var nullable2 = (factory, typeNode, nullable3) => {
  if (nullable3) {
    return factory.UnionTypeNode.create({
      typeNodes: [
        typeNode,
        factory.TypeNode.create({
          type: "null"
        })
      ]
    });
  }
  return typeNode;
};
var generatePropertySignatures2 = (entryPoint, currentPoint, factory, schema, context, convertContext) => {
  if (!schema.properties) {
    return [];
  }
  const required = schema.required || [];
  return Object.entries(schema.properties).map(([propertyName, property]) => {
    if (!property) {
      return factory.PropertySignature.create({
        readOnly: false,
        name: convertContext.escapePropertySignatureName(propertyName),
        optional: !required.includes(propertyName),
        comment: [schema.title, schema.description].filter((v) => !!v).join("\n\n"),
        type: factory.TypeNode.create({
          type: "any"
        })
      });
    }
    return factory.PropertySignature.create({
      readOnly: typeof property !== "boolean" ? !!property.readOnly : false,
      name: convertContext.escapePropertySignatureName(propertyName),
      optional: !required.includes(propertyName),
      type: convert(entryPoint, currentPoint, factory, property, context, convertContext, { parent: schema }),
      comment: typeof property !== "boolean" ? [property.title, property.description].filter((v) => !!v).join("\n\n") : void 0
    });
  });
};
var generateTypeAliasDeclarationForObject = (entryPoint, currentPoint, factory, name, schema, context, convertContext) => {
  if (schema.type !== "object") {
    throw new FeatureDevelopmentError("Please use generateTypeAlias");
  }
  let members = [];
  const propertySignatures = generatePropertySignatures2(entryPoint, currentPoint, factory, schema, context, convertContext);
  if (isObjectSchemaWithAdditionalProperties(schema)) {
    const additionalProperties = convertAdditionalProperties(entryPoint, currentPoint, factory, schema, context, convertContext);
    if (schema.additionalProperties === true) {
      members = members.concat(additionalProperties);
    } else {
      members = [...propertySignatures, additionalProperties];
    }
  } else {
    members = propertySignatures;
  }
  const typeNode = factory.TypeLiteralNode.create({
    members
  });
  return factory.TypeAliasDeclaration.create({
    export: true,
    name: convertContext.escapeDeclarationText(name),
    comment: [schema.title, schema.description].filter((v) => !!v).join("\n\n"),
    type: nullable2(factory, typeNode, schema.nullable === true)
  });
};
var generateInterface2 = (entryPoint, currentPoint, factory, name, schema, context, convertContext) => {
  if (schema.type !== "object") {
    throw new FeatureDevelopmentError("Please use generateTypeAlias");
  }
  let members = [];
  const propertySignatures = generatePropertySignatures2(entryPoint, currentPoint, factory, schema, context, convertContext);
  if (isObjectSchemaWithAdditionalProperties(schema)) {
    const additionalProperties = convertAdditionalProperties(entryPoint, currentPoint, factory, schema, context, convertContext);
    if (schema.additionalProperties === true) {
      members = members.concat(additionalProperties);
    } else {
      members = [...propertySignatures, additionalProperties];
    }
  } else {
    members = propertySignatures;
  }
  return factory.InterfaceDeclaration.create({
    export: true,
    name: convertContext.escapeDeclarationText(name),
    members,
    comment: addComment(schema.description, schema.externalDocs)
  });
};
var generateArrayTypeAlias = (entryPoint, currentPoint, factory, name, schema, context, convertContext) => {
  return factory.TypeAliasDeclaration.create({
    export: true,
    name: convertContext.escapeDeclarationText(name),
    comment: [schema.title, schema.description].filter((v) => !!v).join("\n\n"),
    type: convert(entryPoint, currentPoint, factory, schema, context, convertContext)
  });
};
var createNullableTypeNodeOrAny = (factory, schema) => {
  const typeNode = factory.TypeNode.create({
    type: "any"
  });
  if (!schema.type && typeof schema.nullable === "boolean") {
    return factory.TypeNode.create({
      type: "null"
    });
  }
  return typeNode;
};
var generateNotInferedTypeAlias = (entryPoint, currentPoint, factory, name, schema, convertContext) => {
  const typeNode = createNullableTypeNodeOrAny(factory, schema);
  return factory.TypeAliasDeclaration.create({
    export: true,
    name: convertContext.escapeDeclarationText(name),
    type: typeNode,
    comment: [schema.title, schema.description].filter((v) => !!v).join("\n\n")
  });
};
var generateTypeAlias = (entryPoint, currentPoint, factory, name, schema, convertContext) => {
  let type;
  let formatTypeNode;
  if (schema.format && schema.type !== "any") {
    formatTypeNode = convertContext.convertFormatTypeNode(schema);
  }
  if (formatTypeNode) {
    type = formatTypeNode;
  } else if (schema.enum) {
    if (isNumberArray(schema.enum) && (schema.type === "number" || schema.type === "integer")) {
      type = factory.TypeNode.create({
        type: schema.type,
        enum: schema.enum
      });
    } else if (isStringArray(schema.enum) && schema.type === "string") {
      type = factory.TypeNode.create({
        type: schema.type,
        enum: schema.enum
      });
    } else if (schema.type === "boolean") {
      type = factory.TypeNode.create({
        type: schema.type,
        enum: isBooleanArray(schema.enum) ? schema.enum : void 0
      });
    } else {
      type = factory.TypeNode.create({
        type: schema.type
      });
    }
  } else {
    type = factory.TypeNode.create({
      type: schema.type
    });
  }
  return factory.TypeAliasDeclaration.create({
    export: true,
    name: convertContext.escapeDeclarationText(name),
    type: nullable2(factory, type, schema.nullable === true),
    comment: [schema.title, schema.description].filter((v) => !!v).join("\n\n")
  });
};
var generateMultiTypeAlias = (entryPoint, currentPoint, factory, name, schemas, context, multiType, convertContext) => {
  const type = generateMultiTypeNode(
    entryPoint,
    currentPoint,
    factory,
    schemas,
    context,
    convert,
    convertContext,
    multiType
  );
  return factory.TypeAliasDeclaration.create({
    export: true,
    name: convertContext.escapeDeclarationText(name),
    type
  });
};
var addSchema = (entryPoint, currentPoint, store, factory, targetPoint, declarationName, schema, context, convertContext) => {
  if (!schema) {
    return;
  }
  if (isAllOfSchema(schema)) {
    store.addStatement(targetPoint, {
      kind: "typeAlias",
      name: convertContext.escapeDeclarationText(declarationName),
      value: generateMultiTypeAlias(entryPoint, currentPoint, factory, declarationName, schema.allOf, context, "allOf", convertContext)
    });
  } else if (isOneOfSchema(schema)) {
    store.addStatement(targetPoint, {
      kind: "typeAlias",
      name: convertContext.escapeDeclarationText(declarationName),
      value: generateMultiTypeAlias(entryPoint, currentPoint, factory, declarationName, schema.oneOf, context, "oneOf", convertContext)
    });
  } else if (isAnyOfSchema(schema)) {
    store.addStatement(targetPoint, {
      kind: "typeAlias",
      name: convertContext.escapeDeclarationText(declarationName),
      value: generateMultiTypeAlias(entryPoint, currentPoint, factory, declarationName, schema.anyOf, context, "allOf", convertContext)
    });
  } else if (isArraySchema(schema)) {
    store.addStatement(targetPoint, {
      kind: "typeAlias",
      name: convertContext.escapeDeclarationText(declarationName),
      value: generateArrayTypeAlias(entryPoint, currentPoint, factory, declarationName, schema, context, convertContext)
    });
  } else if (isObjectSchema(schema)) {
    if (schema.nullable) {
      store.addStatement(targetPoint, {
        kind: "typeAlias",
        name: convertContext.escapeDeclarationText(declarationName),
        value: generateTypeAliasDeclarationForObject(entryPoint, currentPoint, factory, declarationName, schema, context, convertContext)
      });
    } else {
      store.addStatement(targetPoint, {
        kind: "interface",
        name: convertContext.escapeDeclarationText(declarationName),
        value: generateInterface2(entryPoint, currentPoint, factory, declarationName, schema, context, convertContext)
      });
    }
  } else if (isPrimitiveSchema(schema)) {
    store.addStatement(targetPoint, {
      kind: "typeAlias",
      name: convertContext.escapeDeclarationText(declarationName),
      value: generateTypeAlias(entryPoint, currentPoint, factory, declarationName, schema, convertContext)
    });
  }
};

// src/internal/OpenApiTools/components/Headers.ts
var generateNamespace = (entryPoint, currentPoint, store, factory, headers, context, converterContext) => {
  store.addComponent("headers", {
    kind: "namespace",
    name: Components.Headers
  });
  Object.entries(headers).forEach(([name, header]) => {
    if (isReference(header)) {
      const reference = generate2(entryPoint, currentPoint, header);
      if (reference.type === "local") {
        if (!store.hasStatement(reference.path, ["interface"])) {
          throw new UndefinedComponent(`Reference "${header.$ref}" did not found in ${reference.path} by ${reference.name}`);
        }
      } else if (reference.type === "remote") {
        addSchema(
          entryPoint,
          currentPoint,
          store,
          factory,
          reference.path,
          reference.name,
          reference.data.schema,
          context,
          converterContext
        );
      }
    } else {
      store.addStatement(`components/headers/${name}`, {
        kind: "typeAlias",
        name: converterContext.escapeDeclarationText(name),
        value: generateTypeNode(entryPoint, currentPoint, factory, name, header, context, converterContext)
      });
    }
  });
};

// src/internal/OpenApiTools/components/Parameter.ts
var generateTypeNode2 = (entryPoint, currentPoint, factory, parameter, context, converterContext) => {
  return convert(entryPoint, currentPoint, factory, parameter.schema || { type: "null" }, context, converterContext);
};
var generateTypeAlias2 = (entryPoint, currentPoint, factory, name, parameter, context, converterContext) => {
  return factory.TypeAliasDeclaration.create({
    export: true,
    name: converterContext.escapeDeclarationText(name),
    comment: parameter.description,
    type: generateTypeNode2(entryPoint, currentPoint, factory, parameter, context, converterContext)
  });
};
var generatePropertySignatureObject = (entryPoint, currentPoint, store, factory, parameter, context, converterContext) => {
  if (isReference(parameter)) {
    const reference = generate2(entryPoint, currentPoint, parameter);
    if (reference.type === "local") {
      context.setReferenceHandler(currentPoint, reference);
      const localRef = store.getParameter(reference.path);
      const isPathProperty3 = localRef.in === "path";
      const name3 = converterContext.escapePropertySignatureName(localRef.name);
      const typeElement3 = factory.PropertySignature.create({
        readOnly: false,
        name: name3,
        optional: isPathProperty3 ? false : !localRef.required,
        comment: localRef.description,
        type: factory.TypeReferenceNode.create({
          name: context.resolveReferencePath(currentPoint, reference.path).name
        })
      });
      return {
        name: name3,
        typeElement: typeElement3
      };
    }
    const isPathProperty2 = reference.data.in === "path";
    const name2 = converterContext.escapePropertySignatureName(reference.data.name);
    const typeElement2 = factory.PropertySignature.create({
      readOnly: false,
      name: name2,
      optional: isPathProperty2 ? false : !reference.data.required,
      comment: reference.data.description,
      type: convert(
        entryPoint,
        reference.referencePoint,
        factory,
        reference.data.schema || { type: "null" },
        context,
        converterContext
      )
    });
    return {
      name: name2,
      typeElement: typeElement2
    };
  }
  const isPathProperty = parameter.in === "path";
  const name = converterContext.escapePropertySignatureName(parameter.name);
  const typeElement = factory.PropertySignature.create({
    readOnly: false,
    name,
    optional: isPathProperty ? false : !parameter.required,
    type: convert(entryPoint, currentPoint, factory, parameter.schema || { type: "null" }, context, converterContext),
    comment: parameter.description
  });
  return {
    name,
    typeElement
  };
};
var generatePropertySignatures3 = (entryPoint, currentPoint, store, factory, parameters, context, converterContext) => {
  const typeElementMap = parameters.reduce((all, parameter) => {
    const { name, typeElement } = generatePropertySignatureObject(
      entryPoint,
      currentPoint,
      store,
      factory,
      parameter,
      context,
      converterContext
    );
    return { ...all, [name]: typeElement };
  }, {});
  return Object.values(typeElementMap);
};
var generateAliasInterface = (entryPoint, currentPoint, store, factory, name, parameters, context, converterContext) => {
  return factory.InterfaceDeclaration.create({
    export: true,
    name: converterContext.escapeDeclarationText(name),
    members: generatePropertySignatures3(entryPoint, currentPoint, store, factory, parameters, context, converterContext)
  });
};

// src/internal/OpenApiTools/components/Parameters.ts
var generateNamespace2 = (entryPoint, currentPoint, store, factory, parameters, context, converterContext) => {
  const basePath = "components/parameters";
  store.addComponent("parameters", {
    kind: "namespace",
    name: Components.Parameters
  });
  Object.entries(parameters).forEach(([name, parameter]) => {
    if (isReference(parameter)) {
      const reference = generate2(entryPoint, currentPoint, parameter);
      if (reference.type === "local") {
        throw new UnSupportError("What is components.parameters local reference?");
      }
      if (!reference.data.schema) {
        return;
      }
      addSchema(
        entryPoint,
        currentPoint,
        store,
        factory,
        reference.path,
        reference.name,
        reference.data.schema,
        context,
        converterContext
      );
      store.addStatement(`${basePath}/${name}`, {
        kind: "typeAlias",
        name: converterContext.escapeDeclarationText(name),
        value: factory.TypeAliasDeclaration.create({
          export: true,
          name: converterContext.escapeDeclarationText(name),
          type: factory.TypeReferenceNode.create({
            name: context.resolveReferencePath(currentPoint, reference.path).name
          })
        })
      });
    } else {
      const path6 = `${basePath}/${name}`;
      store.addStatement(path6, {
        kind: "typeAlias",
        name: converterContext.escapeDeclarationText(name),
        value: generateTypeAlias2(entryPoint, currentPoint, factory, name, parameter, context, converterContext)
      });
    }
  });
};

// src/internal/OpenApiTools/components/RequestBodies.ts
var path3 = __toESM(require("path"), 1);

// src/internal/OpenApiTools/components/MediaType.ts
var generatePropertySignature2 = (entryPoint, currentPoint, factory, protocol, schema, context, converterContext) => {
  return factory.PropertySignature.create({
    readOnly: false,
    name: converterContext.escapePropertySignatureName(protocol),
    optional: false,
    type: convert(entryPoint, currentPoint, factory, schema, context, converterContext),
    comment: schema.description
  });
};
var generatePropertySignatures4 = (entryPoint, currentPoint, factory, content, context, converterContext) => {
  return Object.entries(content).reduce((previous, [protocol, mediaType]) => {
    if (!mediaType.schema) {
      return previous;
    }
    return previous.concat(generatePropertySignature2(entryPoint, currentPoint, factory, protocol, mediaType.schema, context, converterContext));
  }, []);
};
var generateInterface3 = (entryPoint, currentPoint, factory, name, content, context, converterContext) => {
  return factory.InterfaceDeclaration.create({
    export: true,
    name,
    members: generatePropertySignatures4(entryPoint, currentPoint, factory, content, context, converterContext)
  });
};

// src/internal/OpenApiTools/components/RequestBody.ts
var generateInterface4 = (entryPoint, currentPoint, factory, name, requestBody, context, converterContext) => {
  const hasValidMediaType = Object.values(requestBody.content).filter((mediaType) => Object.values(mediaType).length > 0).length > 0;
  const contentSignatures = generatePropertySignatures4(
    entryPoint,
    currentPoint,
    factory,
    hasValidMediaType ? requestBody.content : {},
    context,
    converterContext
  );
  return factory.InterfaceDeclaration.create({
    export: true,
    name,
    members: contentSignatures
  });
};
var generateNamespace3 = (entryPoint, currentPoint, store, factory, parentName, name, requestBody, context, converterContext) => {
  const escapeName = converterContext.escapeDeclarationText(name);
  const basePath = `${parentName}/${name}`;
  store.addStatement(basePath, {
    kind: "namespace",
    name: converterContext.escapeDeclarationText(escapeName),
    comment: requestBody.description
  });
  store.addStatement(`${basePath}/Content`, {
    kind: "interface",
    name: "Content",
    value: generateInterface4(entryPoint, currentPoint, factory, "Content", requestBody, context, converterContext)
  });
};

// src/internal/OpenApiTools/components/RequestBodies.ts
var generateNamespace4 = (entryPoint, currentPoint, store, factory, requestBodies, context, converterContext) => {
  const basePath = "components/requestBodies";
  store.addComponent("requestBodies", {
    kind: "namespace",
    name: Components.RequestBodies
  });
  Object.entries(requestBodies).forEach(([name, requestBody]) => {
    if (isReference(requestBody)) {
      const reference = generate2(entryPoint, currentPoint, requestBody);
      if (reference.type === "local") {
        throw new Error("not support");
      }
      if (reference.type === "remote") {
        generateNamespace3(
          entryPoint,
          reference.referencePoint,
          store,
          factory,
          path3.dirname(reference.path),
          reference.name,
          reference.data,
          context,
          converterContext
        );
      }
    } else {
      generateNamespace3(entryPoint, currentPoint, store, factory, basePath, name, requestBody, context, converterContext);
    }
  });
};

// src/internal/OpenApiTools/components/Responses.ts
var path4 = __toESM(require("path"), 1);

// src/internal/OpenApiTools/components/Response.ts
var generateNamespace5 = (entryPoint, currentPoint, store, factory, parentPath, name, response, context, converterContext) => {
  const basePath = `${parentPath}/${name}`;
  store.addStatement(basePath, {
    kind: "namespace",
    name,
    comment: response.description
  });
  if (response.headers) {
    store.addStatement(`${basePath}/Header`, {
      kind: "interface",
      name: ComponentChild.Header,
      value: generateInterface(
        entryPoint,
        currentPoint,
        factory,
        ComponentChild.Header,
        response.headers,
        context,
        converterContext
      )
    });
  }
  if (response.content) {
    store.addStatement(`${basePath}/Content`, {
      kind: "interface",
      name: ComponentChild.Content,
      value: generateInterface3(
        entryPoint,
        currentPoint,
        factory,
        ComponentChild.Content,
        response.content,
        context,
        converterContext
      )
    });
  }
};

// src/internal/OpenApiTools/components/Responses.ts
var generateNamespace6 = (entryPoint, currentPoint, store, factory, responses, context, converterContext) => {
  const basePath = "components/responses";
  store.addComponent("responses", {
    kind: "namespace",
    name: Components.Responses
  });
  Object.entries(responses).forEach(([name, response]) => {
    if (isReference(response)) {
      const reference = generate2(entryPoint, currentPoint, response);
      if (reference.type === "local") {
        if (!store.hasStatement(reference.path, ["interface"])) {
          throw new UndefinedComponent(`Reference "${response.$ref}" did not found in ${reference.path} by ${reference.name}`);
        }
      } else if (reference.type === "remote") {
        generateNamespace5(
          entryPoint,
          reference.referencePoint,
          store,
          factory,
          path4.posix.dirname(reference.path),
          // referencePoint basename === namespace name
          reference.name,
          reference.data,
          context,
          converterContext
        );
      }
    } else {
      generateNamespace5(entryPoint, currentPoint, store, factory, basePath, name, response, context, converterContext);
    }
  });
};
var generateInterfacesWithStatusCode = (entryPoint, currentPoint, store, factory, operationId, responses, context, converterContext) => {
  const statements = [];
  Object.entries(responses).forEach(([statusCode, response]) => {
    if (!response) {
      return;
    }
    if (isReference(response)) {
      const reference = generate2(entryPoint, currentPoint, response);
      if (reference.type === "local") {
        context.setReferenceHandler(currentPoint, reference);
        const { maybeResolvedName, unresolvedPaths } = context.resolveReferencePath(currentPoint, `${reference.path}/Content`);
        if (unresolvedPaths.length === 0) {
          statements.push(
            factory.TypeAliasDeclaration.create({
              export: true,
              name: converterContext.generateResponseName(operationId, statusCode),
              type: factory.TypeReferenceNode.create({
                name: maybeResolvedName
              })
            })
          );
        }
      } else if (reference.componentName) {
        generateNamespace5(
          entryPoint,
          reference.referencePoint,
          store,
          factory,
          path4.posix.dirname(reference.path),
          // referencePoint basename === namespace name
          reference.name,
          reference.data,
          context,
          converterContext
        );
        const content = reference.data.content;
        if (content) {
          statements.push(
            generateInterface3(
              entryPoint,
              reference.referencePoint,
              factory,
              converterContext.generateResponseName(operationId, statusCode),
              content,
              context,
              converterContext
            )
          );
        }
      }
    } else {
      if (response.content) {
        statements.push(
          generateInterface3(
            entryPoint,
            currentPoint,
            factory,
            converterContext.generateResponseName(operationId, statusCode),
            response.content,
            context,
            converterContext
          )
        );
      }
    }
  });
  return statements;
};

// src/internal/OpenApiTools/components/Schemas.ts
var generateNamespace7 = (entryPoint, currentPoint, store, factory, schemas, context, convertContext) => {
  const basePath = "components/schemas";
  store.addComponent("schemas", {
    kind: "namespace",
    name: Components.Schemas
  });
  Object.entries(schemas).forEach(([name, targetSchema]) => {
    if (isReference(targetSchema)) {
      const schema2 = targetSchema;
      const reference = generate2(entryPoint, currentPoint, schema2);
      if (reference.type === "local") {
        const { maybeResolvedName, depth, pathArray } = context.resolveReferencePath(currentPoint, reference.path);
        const createTypeNode = () => {
          if (depth === 2) {
            return factory.TypeReferenceNode.create({
              name: convertContext.escapeReferenceDeclarationText(maybeResolvedName)
            });
          }
          const schema3 = context.findSchemaByPathArray(pathArray);
          return convert(entryPoint, currentPoint, factory, schema3, context, convertContext, { parent: schema3 });
        };
        return store.addStatement(`${basePath}/${name}`, {
          kind: "typeAlias",
          name: convertContext.escapeDeclarationText(name),
          value: factory.TypeAliasDeclaration.create({
            export: true,
            name: convertContext.escapeDeclarationText(name),
            type: createTypeNode()
          })
        });
      }
      addSchema(
        entryPoint,
        reference.referencePoint,
        store,
        factory,
        reference.path,
        reference.name,
        reference.data,
        context,
        convertContext
      );
      if (store.hasStatement(`${basePath}/${name}`, ["interface", "typeAlias"])) {
        return;
      }
      return store.addStatement(`${basePath}/${name}`, {
        kind: "typeAlias",
        name: convertContext.escapeDeclarationText(name),
        value: factory.TypeAliasDeclaration.create({
          export: true,
          name: convertContext.escapeDeclarationText(name),
          comment: reference.data.description,
          type: factory.TypeReferenceNode.create({
            name: convertContext.escapeReferenceDeclarationText(context.resolveReferencePath(currentPoint, reference.path).name)
          })
        })
      });
    }
    const schema = getInferredType(targetSchema);
    const path6 = `${basePath}/${name}`;
    if (!schema) {
      warn(`Warning: Schema could not be identified. Therefore, it is treated as any. ${name}`);
      return store.addStatement(
        path6,
        {
          kind: "typeAlias",
          name: convertContext.escapeDeclarationText(name),
          value: generateNotInferedTypeAlias(entryPoint, currentPoint, factory, name, targetSchema, convertContext)
        },
        { override: true }
      );
    }
    if (isAllOfSchema(schema)) {
      return store.addStatement(
        path6,
        {
          kind: "typeAlias",
          name: convertContext.escapeDeclarationText(name),
          value: generateMultiTypeAlias(entryPoint, currentPoint, factory, name, schema.allOf, context, "allOf", convertContext)
        },
        { override: true }
      );
    }
    if (isOneOfSchema(schema)) {
      return store.addStatement(
        path6,
        {
          kind: "typeAlias",
          name: convertContext.escapeDeclarationText(name),
          value: generateMultiTypeAlias(entryPoint, currentPoint, factory, name, schema.oneOf, context, "oneOf", convertContext)
        },
        { override: true }
      );
    }
    if (isAnyOfSchema(schema)) {
      return store.addStatement(
        path6,
        {
          kind: "typeAlias",
          name: convertContext.escapeDeclarationText(name),
          value: generateMultiTypeAlias(entryPoint, currentPoint, factory, name, schema.anyOf, context, "anyOf", convertContext)
        },
        { override: true }
      );
    }
    if (isArraySchema(schema)) {
      return store.addStatement(
        path6,
        {
          kind: "typeAlias",
          name: convertContext.escapeDeclarationText(name),
          value: generateArrayTypeAlias(entryPoint, currentPoint, factory, name, schema, context, convertContext)
        },
        { override: true }
      );
    }
    if (isObjectSchema(schema)) {
      if (schema.nullable) {
        return store.addStatement(
          path6,
          {
            kind: "typeAlias",
            name: convertContext.escapeDeclarationText(name),
            value: generateTypeAliasDeclarationForObject(entryPoint, currentPoint, factory, name, schema, context, convertContext)
          },
          { override: true }
        );
      }
      return store.addStatement(
        path6,
        {
          kind: "interface",
          name: convertContext.escapeDeclarationText(name),
          value: generateInterface2(entryPoint, currentPoint, factory, name, schema, context, convertContext)
        },
        { override: true }
      );
    }
    if (isPrimitiveSchema(schema)) {
      return store.addStatement(
        path6,
        {
          kind: "typeAlias",
          name,
          value: generateTypeAlias(entryPoint, currentPoint, factory, name, schema, convertContext)
        },
        { override: true }
      );
    }
    throw new UnSupportError(`schema.type = Array[] not supported. ${JSON.stringify(schema)}`);
  });
};

// src/internal/OpenApiTools/components/Operation.ts
var path5 = __toESM(require("path"), 1);
var generateStatements = (entryPoint, currentPoint, store, factory, requestUri, httpMethod, operation, pathItemParameters, context, converterContext) => {
  let statements = [];
  const operationId = operation.operationId;
  if (!operationId) {
    throw new Error(`not setting operationId
${JSON.stringify(operation)}`);
  }
  store.updateOperationState(httpMethod, requestUri, operationId, {});
  const parameters = [...pathItemParameters || [], ...operation.parameters || []];
  if (parameters.length > 0) {
    const parameterName2 = converterContext.generateParameterName(operationId);
    statements.push(
      generateAliasInterface(entryPoint, currentPoint, store, factory, parameterName2, parameters, context, converterContext)
    );
  }
  if (operation.requestBody) {
    const requestBodyName2 = converterContext.generateRequestBodyName(operationId);
    if (isReference(operation.requestBody)) {
      const reference = generate2(entryPoint, currentPoint, operation.requestBody);
      if (reference.type === "local") {
        context.setReferenceHandler(currentPoint, reference);
        statements.push(
          factory.TypeAliasDeclaration.create({
            export: true,
            name: converterContext.generateRequestBodyName(operationId),
            type: factory.TypeReferenceNode.create({
              name: `${context.resolveReferencePath(currentPoint, `${reference.path}`).name}.${ComponentChild.Content}`
              // TODO Contextから作成？
            })
          })
        );
      } else if (reference.type === "remote" && reference.componentName) {
        const contentPath = path5.join(reference.path, "Content");
        const name = "Content";
        store.addStatement(contentPath, {
          kind: "interface",
          name,
          value: generateInterface4(entryPoint, reference.referencePoint, factory, name, reference.data, context, converterContext)
        });
        statements.push(
          factory.TypeAliasDeclaration.create({
            export: true,
            name: converterContext.escapeDeclarationText(requestBodyName2),
            type: factory.TypeReferenceNode.create({ name: context.resolveReferencePath(currentPoint, contentPath).name })
          })
        );
        store.updateOperationState(httpMethod, requestUri, operationId, {
          requestBodyName: requestBodyName2
        });
      }
    } else {
      const hasValidMediaType = Object.values(operation.requestBody.content).filter((mediaType) => Object.values(mediaType).length > 0).length > 0;
      if (hasValidMediaType) {
        statements.push(
          generateInterface4(entryPoint, currentPoint, factory, requestBodyName2, operation.requestBody, context, converterContext)
        );
        store.updateOperationState(httpMethod, requestUri, operationId, {
          requestBodyName: requestBodyName2
        });
      }
    }
  }
  if (operation.responses) {
    statements = statements.concat(
      generateInterfacesWithStatusCode(
        entryPoint,
        currentPoint,
        store,
        factory,
        operationId,
        operation.responses,
        context,
        converterContext
      ).flat()
    );
  }
  return statements;
};

// src/internal/OpenApiTools/components/PathItem.ts
var generateStatements2 = (entryPoint, currentPoint, store, factory, requestUri, pathItem, context, converterContext) => {
  const statements = [];
  if (pathItem.get) {
    statements.push(
      generateStatements(
        entryPoint,
        currentPoint,
        store,
        factory,
        requestUri,
        "GET",
        pathItem.get,
        pathItem.parameters,
        context,
        converterContext
      )
    );
  }
  if (pathItem.put) {
    statements.push(
      generateStatements(
        entryPoint,
        currentPoint,
        store,
        factory,
        requestUri,
        "PUT",
        pathItem.put,
        pathItem.parameters,
        context,
        converterContext
      )
    );
  }
  if (pathItem.post) {
    statements.push(
      generateStatements(
        entryPoint,
        currentPoint,
        store,
        factory,
        requestUri,
        "POST",
        pathItem.post,
        pathItem.parameters,
        context,
        converterContext
      )
    );
  }
  if (pathItem.delete) {
    statements.push(
      generateStatements(
        entryPoint,
        currentPoint,
        store,
        factory,
        requestUri,
        "DELETE",
        pathItem.delete,
        pathItem.parameters,
        context,
        converterContext
      )
    );
  }
  if (pathItem.options) {
    statements.push(
      generateStatements(
        entryPoint,
        currentPoint,
        store,
        factory,
        requestUri,
        "OPTIONS",
        pathItem.options,
        pathItem.parameters,
        context,
        converterContext
      )
    );
  }
  if (pathItem.head) {
    statements.push(
      generateStatements(
        entryPoint,
        currentPoint,
        store,
        factory,
        requestUri,
        "HEAD",
        pathItem.head,
        pathItem.parameters,
        context,
        converterContext
      )
    );
  }
  if (pathItem.patch) {
    statements.push(
      generateStatements(
        entryPoint,
        currentPoint,
        store,
        factory,
        requestUri,
        "PATCH",
        pathItem.patch,
        pathItem.parameters,
        context,
        converterContext
      )
    );
  }
  if (pathItem.trace) {
    statements.push(
      generateStatements(
        entryPoint,
        currentPoint,
        store,
        factory,
        requestUri,
        "TRACE",
        pathItem.trace,
        pathItem.parameters,
        context,
        converterContext
      )
    );
  }
  return statements.flat();
};

// src/internal/OpenApiTools/paths/index.ts
var generateStatements3 = (entryPoint, currentPoint, store, factory, paths, context, converterContext) => {
  const statements = [];
  for (const [requestUri, pathItem] of Object.entries(paths)) {
    if (!requestUri.startsWith("/")) {
      throw new Error(`Not start slash: ${requestUri}`);
    }
    if (isReference(pathItem)) {
      const reference = generate2(entryPoint, currentPoint, pathItem);
      if (reference.type === "local") {
        statements.push(
          generateStatements2(
            entryPoint,
            currentPoint,
            store,
            factory,
            requestUri,
            store.getPathItem(reference.path),
            context,
            converterContext
          )
        );
      } else {
        statements.push(
          generateStatements2(
            entryPoint,
            reference.referencePoint,
            store,
            factory,
            requestUri,
            reference.data,
            context,
            converterContext
          )
        );
      }
    } else {
      statements.push(generateStatements2(entryPoint, currentPoint, store, factory, requestUri, pathItem, context, converterContext));
    }
  }
  store.addAdditionalStatement(statements.flat());
};

// src/internal/OpenApiTools/Parser.ts
var Parser = class {
  constructor(entryPoint, rootSchema, noReferenceOpenApiSchema, convertOption) {
    this.entryPoint = entryPoint;
    this.rootSchema = rootSchema;
    this.currentPoint = entryPoint;
    this.factory = factory_exports.create();
    this.convertContext = create45(this.factory, convertOption);
    this.store = new Store(this.factory, noReferenceOpenApiSchema);
    this.initialize();
  }
  currentPoint;
  convertContext;
  store;
  factory;
  initialize() {
    const toTypeNodeContext = create46(this.entryPoint, this.rootSchema, this.store, this.factory, this.convertContext);
    const rootSchema = this.rootSchema;
    if (rootSchema.components) {
      if (rootSchema.components.schemas) {
        generateNamespace7(
          this.entryPoint,
          this.currentPoint,
          this.store,
          this.factory,
          rootSchema.components.schemas,
          toTypeNodeContext,
          this.convertContext
        );
      }
      if (rootSchema.components.headers) {
        generateNamespace(
          this.entryPoint,
          this.currentPoint,
          this.store,
          this.factory,
          rootSchema.components.headers,
          toTypeNodeContext,
          this.convertContext
        );
      }
      if (rootSchema.components.responses) {
        generateNamespace6(
          this.entryPoint,
          this.currentPoint,
          this.store,
          this.factory,
          rootSchema.components.responses,
          toTypeNodeContext,
          this.convertContext
        );
      }
      if (rootSchema.components.parameters) {
        generateNamespace2(
          this.entryPoint,
          this.currentPoint,
          this.store,
          this.factory,
          rootSchema.components.parameters,
          toTypeNodeContext,
          this.convertContext
        );
      }
      if (rootSchema.components.requestBodies) {
        generateNamespace4(
          this.entryPoint,
          this.currentPoint,
          this.store,
          this.factory,
          rootSchema.components.requestBodies,
          toTypeNodeContext,
          this.convertContext
        );
      }
    }
    if (rootSchema.paths) {
      generateStatements3(
        this.entryPoint,
        this.currentPoint,
        this.store,
        this.factory,
        rootSchema.paths,
        toTypeNodeContext,
        this.convertContext
      );
    }
  }
  getCodeGeneratorParamsArray(allowOperationIds) {
    return generateCodeGeneratorParamsArray(this.store, this.convertContext, allowOperationIds);
  }
  getOpenApiTypeDefinitionStatements() {
    return this.store.getRootStatements();
  }
  getAdditionalTypeStatements() {
    return this.store.getAdditionalStatements();
  }
};

// src/internal/ResolveReference/index.ts
var ResolveReference_exports = {};
__export(ResolveReference_exports, {
  resolve: () => resolve
});
var escapeFromJsonCyclic = (obj) => {
  if (!obj) {
    return obj;
  }
  return JSON.parse(JSON.stringify(obj));
};
var isObject2 = (value) => {
  return !!value && value !== null && !Array.isArray(value) && typeof value === "object";
};
var isArray = (value) => {
  return !!value && Array.isArray(value);
};
var isRemoteReference = (obj) => {
  if (!isObject2(obj)) {
    return false;
  }
  if (typeof obj.$ref !== "string") {
    return false;
  }
  if (obj.$ref.startsWith("#")) {
    return false;
  }
  if (obj.$ref.startsWith("http://") || obj.$ref.startsWith("https://")) {
    return true;
  }
  return true;
};
var isLocalReference = (obj) => {
  return !isRemoteReference(obj);
};
var resolveRemoteReference2 = (entryPoint, currentPoint, obj, parentKey) => {
  if (isReference(obj)) {
    if (isLocalReference(obj)) {
      return obj;
    }
    if (isRemoteReference(obj)) {
      const { referencePoint, data } = resolveRemoteReference(entryPoint, currentPoint, obj);
      if (!data) {
        throw new Error(`not defined schema: ${obj.$ref}`);
      }
      if (isArray(data)) {
        return data.map((item, idx) => resolveRemoteReference2(entryPoint, referencePoint, item, [parentKey, idx].join(".")));
      }
      if (isObject2(data)) {
        Object.entries(data).forEach(([key, value]) => {
          data[key] = resolveRemoteReference2(entryPoint, referencePoint, value, [parentKey, key].join("."));
        });
        return data;
      }
    }
    return obj;
  }
  if (isArray(obj)) {
    return obj.map((item, idx) => resolveRemoteReference2(entryPoint, currentPoint, item, [parentKey, idx].join(".")));
  }
  if (isObject2(obj)) {
    Object.entries(obj).forEach(([key, value]) => {
      obj[key] = resolveRemoteReference2(entryPoint, currentPoint, value, [parentKey, key].join("."));
    });
  }
  return obj;
};
var resolveLocalReference = (entryPoint, currentPoint, obj, rootSchema, parentKey) => {
  if (isReference(obj)) {
    if (isRemoteReference(obj)) {
      if (obj.$ref.startsWith("http")) {
        console.warn(`Feature support: ${obj.$ref}`);
        return {};
      }
      throw new DevelopmentError(`\u307E\u305A\u306Fremote reference\u3092\u89E3\u6C7A\u3057\u3066\u304F\u3060\u3055\u3044
${JSON.stringify(obj, null, 2)}`);
    }
    if (isLocalReference(obj)) {
      const ref = generateLocalReference(obj);
      if (!ref) {
        throw new DevelopmentError(
          "This is an implementation error. Please report any reproducible information below.\nhttps://github.com/Himenon/openapi-typescript-code-generator/issues/new/choose\n"
        );
      }
      const escapedPath = ref.path.replace(/\./g, "\\.").replace(/\//g, ".");
      return escapeFromJsonCyclic(getProperty(rootSchema, escapedPath));
    }
    return obj;
  }
  if (isArray(obj)) {
    return obj.map((item, idx) => resolveLocalReference(entryPoint, currentPoint, item, rootSchema, [parentKey, idx].join(".")));
  }
  if (isObject2(obj)) {
    Object.entries(obj).forEach(([key, value]) => {
      obj[key] = resolveLocalReference(entryPoint, currentPoint, value, rootSchema, [parentKey, key].join("."));
    });
  }
  return obj;
};
var resolve = (entryPoint, currentPoint, rootSchema) => {
  const obj1 = resolveRemoteReference2(entryPoint, currentPoint, rootSchema, "remote");
  const obj2 = resolveLocalReference(entryPoint, currentPoint, obj1, obj1, "local");
  return obj2;
};

// src/internal/Validator/index.ts
var Validator_exports = {};
__export(Validator_exports, {
  validate: () => validate
});
var Ajv = __toESM(require("ajv"), 1);

// src/internal/Validator/openapi.json
var openapi_default = {
  title: "A JSON Schema for OpenAPI 3.0.",
  $schema: "http://json-schema.org/draft-07/schema#",
  type: "object",
  description: "This is the root document object of the OpenAPI document.",
  required: ["openapi", "info"],
  additionalProperties: false,
  patternProperties: {
    "^x-": {
      $ref: "#/definitions/specificationExtension"
    }
  },
  properties: {
    openapi: {
      type: "string"
    },
    info: {
      $ref: "#/definitions/info"
    },
    servers: {
      type: "array",
      items: {
        $ref: "#/definitions/server"
      },
      uniqueItems: true
    },
    paths: {
      $ref: "#/definitions/paths"
    },
    components: {
      $ref: "#/definitions/components"
    },
    security: {
      type: "array",
      items: {
        $ref: "#/definitions/securityRequirement"
      },
      uniqueItems: true
    },
    tags: {
      type: "array",
      items: {
        $ref: "#/definitions/tag"
      },
      uniqueItems: true
    },
    externalDocs: {
      $ref: "#/definitions/externalDocs"
    }
  },
  definitions: {
    info: {
      type: "object",
      description: "The object provides metadata about the API. The metadata MAY be used by the clients if needed, and MAY be presented in editing or documentation generation tools for convenience.",
      required: ["title", "version"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        title: {
          type: "string"
        },
        description: {
          type: "string"
        },
        termsOfService: {
          type: "string"
        },
        contact: {
          $ref: "#/definitions/contact"
        },
        license: {
          $ref: "#/definitions/license"
        },
        version: {
          type: "string"
        }
      }
    },
    contact: {
      type: "object",
      description: "Contact information for the exposed API.",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        name: {
          type: "string"
        },
        url: {
          type: "string"
        },
        email: {
          type: "string"
        }
      }
    },
    license: {
      type: "object",
      description: "License information for the exposed API.",
      required: ["name"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        name: {
          type: "string"
        },
        url: {
          type: "string"
        }
      }
    },
    server: {
      type: "object",
      description: "An object representing a Server.",
      required: ["url"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        url: {
          type: "string"
        },
        description: {
          type: "string"
        },
        variables: {
          $ref: "#/definitions/serverVariables"
        }
      }
    },
    serverVariable: {
      type: "object",
      description: "An object representing a Server Variable for server URL template substitution.",
      required: ["default"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        enum: {
          type: "array",
          items: {
            type: "string"
          },
          uniqueItems: true
        },
        default: {
          type: "string"
        },
        description: {
          type: "string"
        }
      }
    },
    components: {
      type: "object",
      description: "Holds a set of reusable objects for different aspects of the OAS. All objects defined within the components object will have no effect on the API unless they are explicitly referenced from properties outside the components object.",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        schemas: {
          $ref: "#/definitions/schemasOrReferences"
        },
        responses: {
          $ref: "#/definitions/responsesOrReferences"
        },
        parameters: {
          $ref: "#/definitions/parametersOrReferences"
        },
        examples: {
          $ref: "#/definitions/examplesOrReferences"
        },
        requestBodies: {
          $ref: "#/definitions/requestBodiesOrReferences"
        },
        headers: {
          $ref: "#/definitions/headersOrReferences"
        },
        securitySchemes: {
          $ref: "#/definitions/securitySchemesOrReferences"
        },
        links: {
          $ref: "#/definitions/linksOrReferences"
        },
        callbacks: {
          $ref: "#/definitions/callbacksOrReferences"
        },
        pathItems: {
          $ref: "#/definitions/pathItemsOrReferences"
        }
      }
    },
    paths: {
      type: "object",
      description: "Holds the relative paths to the individual endpoints and their operations. The path is appended to the URL from the `Server Object` in order to construct the full URL.  The Paths MAY be empty, due to ACL constraints.",
      additionalProperties: false,
      patternProperties: {
        "^/": {
          $ref: "#/definitions/pathItem"
        },
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      }
    },
    pathItemsOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/pathItemsOrReference"
      }
    },
    pathItem: {
      type: "object",
      description: "Describes the operations available on a single path. A Path Item MAY be empty, due to ACL constraints. The path itself is still exposed to the documentation viewer but they will not know which operations and parameters are available.",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        $ref: {
          type: "string"
        },
        summary: {
          type: "string"
        },
        description: {
          type: "string"
        },
        get: {
          $ref: "#/definitions/operation"
        },
        put: {
          $ref: "#/definitions/operation"
        },
        post: {
          $ref: "#/definitions/operation"
        },
        delete: {
          $ref: "#/definitions/operation"
        },
        options: {
          $ref: "#/definitions/operation"
        },
        head: {
          $ref: "#/definitions/operation"
        },
        patch: {
          $ref: "#/definitions/operation"
        },
        trace: {
          $ref: "#/definitions/operation"
        },
        servers: {
          type: "array",
          items: {
            $ref: "#/definitions/server"
          },
          uniqueItems: true
        },
        parameters: {
          type: "array",
          items: {
            $ref: "#/definitions/parameterOrReference"
          },
          uniqueItems: true
        }
      }
    },
    operation: {
      type: "object",
      description: "Describes a single API operation on a path.",
      required: ["responses"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        tags: {
          type: "array",
          items: {
            type: "string"
          },
          uniqueItems: true
        },
        summary: {
          type: "string"
        },
        description: {
          type: "string"
        },
        externalDocs: {
          $ref: "#/definitions/externalDocs"
        },
        operationId: {
          type: "string"
        },
        parameters: {
          type: "array",
          items: {
            $ref: "#/definitions/parameterOrReference"
          },
          uniqueItems: true
        },
        requestBody: {
          $ref: "#/definitions/requestBodyOrReference"
        },
        responses: {
          $ref: "#/definitions/responses"
        },
        callbacks: {
          $ref: "#/definitions/callbacksOrReferences"
        },
        deprecated: {
          type: "boolean"
        },
        security: {
          type: "array",
          items: {
            $ref: "#/definitions/securityRequirement"
          },
          uniqueItems: true
        },
        servers: {
          type: "array",
          items: {
            $ref: "#/definitions/server"
          },
          uniqueItems: true
        }
      }
    },
    externalDocs: {
      type: "object",
      description: "Allows referencing an external resource for extended documentation.",
      required: ["url"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        description: {
          type: "string"
        },
        url: {
          type: "string"
        }
      }
    },
    parameter: {
      type: "object",
      description: "Describes a single operation parameter.  A unique parameter is defined by a combination of a name and location.",
      required: ["name", "in"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        name: {
          type: "string"
        },
        in: {
          type: "string"
        },
        description: {
          type: "string"
        },
        required: {
          type: "boolean"
        },
        deprecated: {
          type: "boolean"
        },
        allowEmptyValue: {
          type: "boolean"
        },
        style: {
          type: "string"
        },
        explode: {
          type: "boolean"
        },
        allowReserved: {
          type: "boolean"
        },
        schema: {
          $ref: "#/definitions/schemaOrReference"
        },
        example: {
          $ref: "#/definitions/any"
        },
        examples: {
          $ref: "#/definitions/examplesOrReferences"
        },
        content: {
          $ref: "#/definitions/mediaTypes"
        }
      }
    },
    requestBody: {
      type: "object",
      description: "Describes a single request body.",
      required: ["content"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        description: {
          type: "string"
        },
        content: {
          $ref: "#/definitions/mediaTypes"
        },
        required: {
          type: "boolean"
        }
      }
    },
    mediaType: {
      type: "object",
      description: "Each Media Type Object provides schema and examples for the media type identified by its key.",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        schema: {
          $ref: "#/definitions/schemaOrReference"
        },
        example: {
          $ref: "#/definitions/any"
        },
        examples: {
          $ref: "#/definitions/examplesOrReferences"
        },
        encoding: {
          $ref: "#/definitions/encodings"
        }
      }
    },
    encoding: {
      type: "object",
      description: "A single encoding definition applied to a single schema property.",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        contentType: {
          type: "string"
        },
        headers: {
          $ref: "#/definitions/headersOrReferences"
        },
        style: {
          type: "string"
        },
        explode: {
          type: "boolean"
        },
        allowReserved: {
          type: "boolean"
        }
      }
    },
    responses: {
      type: "object",
      description: "A container for the expected responses of an operation. The container maps a HTTP response code to the expected response.  The documentation is not necessarily expected to cover all possible HTTP response codes because they may not be known in advance. However, documentation is expected to cover a successful operation response and any known errors.  The `default` MAY be used as a default response object for all HTTP codes  that are not covered individually by the specification.  The `Responses Object` MUST contain at least one response code, and it  SHOULD be the response for a successful operation call.",
      additionalProperties: false,
      patternProperties: {
        "^([0-9X]{3})$": {
          $ref: "#/definitions/responseOrReference"
        },
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        default: {
          $ref: "#/definitions/responseOrReference"
        }
      }
    },
    response: {
      type: "object",
      description: "Describes a single response from an API Operation, including design-time, static  `links` to operations based on the response.",
      required: ["description"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        description: {
          type: "string"
        },
        headers: {
          $ref: "#/definitions/headersOrReferences"
        },
        content: {
          $ref: "#/definitions/mediaTypes"
        },
        links: {
          $ref: "#/definitions/linksOrReferences"
        }
      }
    },
    callback: {
      type: "object",
      description: "A map of possible out-of band callbacks related to the parent operation. Each value in the map is a Path Item Object that describes a set of requests that may be initiated by the API provider and the expected responses. The key value used to identify the callback object is an expression, evaluated at runtime, that identifies a URL to use for the callback operation.",
      additionalProperties: false,
      patternProperties: {
        "^": {
          $ref: "#/definitions/pathItem"
        },
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      }
    },
    example: {
      type: "object",
      description: "",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        summary: {
          type: "string"
        },
        description: {
          type: "string"
        },
        value: {
          $ref: "#/definitions/defaultType"
        },
        externalValue: {
          type: "string"
        }
      }
    },
    link: {
      type: "object",
      description: "The `Link object` represents a possible design-time link for a response. The presence of a link does not guarantee the caller's ability to successfully invoke it, rather it provides a known relationship and traversal mechanism between responses and other operations.  Unlike _dynamic_ links (i.e. links provided **in** the response payload), the OAS linking mechanism does not require link information in the runtime response.  For computing links, and providing instructions to execute them, a runtime expression is used for accessing values in an operation and using them as parameters while invoking the linked operation.",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        operationRef: {
          type: "string"
        },
        operationId: {
          type: "string"
        },
        parameters: {
          $ref: "#/definitions/anysOrExpressions"
        },
        requestBody: {
          $ref: "#/definitions/anyOrExpression"
        },
        description: {
          type: "string"
        },
        server: {
          $ref: "#/definitions/server"
        }
      }
    },
    header: {
      type: "object",
      description: "The Header Object follows the structure of the Parameter Object with the following changes:  1. `name` MUST NOT be specified, it is given in the corresponding `headers` map. 1. `in` MUST NOT be specified, it is implicitly in `header`. 1. All traits that are affected by the location MUST be applicable to a location of `header` (for example, `style`).",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        description: {
          type: "string"
        },
        required: {
          type: "boolean"
        },
        deprecated: {
          type: "boolean"
        },
        allowEmptyValue: {
          type: "boolean"
        },
        style: {
          type: "string"
        },
        explode: {
          type: "boolean"
        },
        allowReserved: {
          type: "boolean"
        },
        schema: {
          $ref: "#/definitions/schemaOrReference"
        },
        example: {
          $ref: "#/definitions/any"
        },
        examples: {
          $ref: "#/definitions/examplesOrReferences"
        },
        content: {
          $ref: "#/definitions/mediaTypes"
        }
      }
    },
    tag: {
      type: "object",
      description: "Adds metadata to a single tag that is used by the Operation Object. It is not mandatory to have a Tag Object per tag defined in the Operation Object instances.",
      required: ["name"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        name: {
          type: "string"
        },
        description: {
          type: "string"
        },
        externalDocs: {
          $ref: "#/definitions/externalDocs"
        }
      }
    },
    examples: {
      type: "object",
      description: "",
      additionalProperties: false
    },
    reference: {
      type: "object",
      description: "A simple object to allow referencing other components in the specification, internally and externally.  The Reference Object is defined by JSON Reference and follows the same structure, behavior and rules.   For this specification, reference resolution is accomplished as defined by the JSON Reference specification and not by the JSON Schema specification.",
      required: ["$ref"],
      additionalProperties: false,
      properties: {
        $ref: {
          type: "string"
        }
      }
    },
    schema: {
      type: "object",
      description: "The Schema Object allows the definition of input and output data types. These types can be objects, but also primitives and arrays. This object is an extended subset of the JSON Schema Specification Wright Draft 00.  For more information about the properties, see JSON Schema Core and JSON Schema Validation. Unless stated otherwise, the property definitions follow the JSON Schema.",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        nullable: {
          type: "boolean"
        },
        discriminator: {
          $ref: "#/definitions/discriminator"
        },
        readOnly: {
          type: "boolean"
        },
        writeOnly: {
          type: "boolean"
        },
        xml: {
          $ref: "#/definitions/xml"
        },
        externalDocs: {
          $ref: "#/definitions/externalDocs"
        },
        example: {
          oneOf: [
            {
              type: "null"
            },
            {
              type: "number"
            },
            {
              type: "boolean"
            },
            {
              type: "string"
            },
            {
              type: "object"
            },
            {
              type: "array"
            }
          ]
        },
        deprecated: {
          type: "boolean"
        },
        title: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/title"
        },
        multipleOf: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/multipleOf"
        },
        maximum: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/maximum"
        },
        exclusiveMaximum: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/exclusiveMaximum"
        },
        minimum: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/minimum"
        },
        exclusiveMinimum: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/exclusiveMinimum"
        },
        maxLength: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/maxLength"
        },
        minLength: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/minLength"
        },
        maxItems: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/maxItems"
        },
        pattern: {
          type: "string"
        },
        minItems: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/minItems"
        },
        uniqueItems: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/uniqueItems"
        },
        maxProperties: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/maxProperties"
        },
        minProperties: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/minProperties"
        },
        required: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/required"
        },
        enum: {
          $ref: "http://json-schema.org/draft-07/schema#/properties/enum"
        },
        type: {
          type: "string"
        },
        allOf: {
          type: "array",
          items: {
            $ref: "#/definitions/schemaOrReference"
          },
          minItems: 1
        },
        oneOf: {
          type: "array",
          items: {
            $ref: "#/definitions/schemaOrReference"
          },
          minItems: 1
        },
        anyOf: {
          type: "array",
          items: {
            $ref: "#/definitions/schemaOrReference"
          },
          minItems: 1
        },
        not: {
          $ref: "#/definitions/schema"
        },
        items: {
          anyOf: [
            {
              $ref: "#/definitions/schemaOrReference"
            },
            {
              type: "array",
              items: {
                $ref: "#/definitions/schemaOrReference"
              },
              minItems: 1
            }
          ]
        },
        properties: {
          type: "object",
          additionalProperties: {
            $ref: "#/definitions/schemaOrReference"
          }
        },
        additionalProperties: {
          oneOf: [
            {
              $ref: "#/definitions/schemaOrReference"
            },
            {
              type: "boolean"
            }
          ]
        },
        default: {
          $ref: "#/definitions/defaultType"
        },
        description: {
          type: "string"
        },
        format: {
          type: "string"
        }
      }
    },
    discriminator: {
      type: "object",
      description: "When request bodies or response payloads may be one of a number of different schemas, a `discriminator` object can be used to aid in serialization, deserialization, and validation.  The discriminator is a specific object in a schema which is used to inform the consumer of the specification of an alternative schema based on the value associated with it.  When using the discriminator, _inline_ schemas will not be considered.",
      required: ["propertyName"],
      additionalProperties: false,
      properties: {
        propertyName: {
          type: "string"
        },
        mapping: {
          $ref: "#/definitions/strings"
        }
      }
    },
    xml: {
      type: "object",
      description: "A metadata object that allows for more fine-tuned XML model definitions.  When using arrays, XML element names are *not* inferred (for singular/plural forms) and the `name` property SHOULD be used to add that information. See examples for expected behavior.",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        name: {
          type: "string"
        },
        namespace: {
          type: "string"
        },
        prefix: {
          type: "string"
        },
        attribute: {
          type: "boolean"
        },
        wrapped: {
          type: "boolean"
        }
      }
    },
    securityScheme: {
      type: "object",
      description: "Defines a security scheme that can be used by the operations. Supported schemes are HTTP authentication, an API key (either as a header or as a query parameter), OAuth2's common flows (implicit, password, application and access code) as defined in RFC6749, and OpenID Connect Discovery.",
      required: ["type"],
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        type: {
          type: "string"
        },
        description: {
          type: "string"
        },
        name: {
          type: "string"
        },
        in: {
          type: "string"
        },
        scheme: {
          type: "string"
        },
        bearerFormat: {
          type: "string"
        },
        flows: {
          $ref: "#/definitions/oauthFlows"
        },
        openIdConnectUrl: {
          type: "string"
        }
      }
    },
    oauthFlows: {
      type: "object",
      description: "Allows configuration of the supported OAuth Flows.",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        implicit: {
          $ref: "#/definitions/oauthFlow"
        },
        password: {
          $ref: "#/definitions/oauthFlow"
        },
        clientCredentials: {
          $ref: "#/definitions/oauthFlow"
        },
        authorizationCode: {
          $ref: "#/definitions/oauthFlow"
        }
      }
    },
    oauthFlow: {
      type: "object",
      description: "Configuration details for a supported OAuth Flow",
      additionalProperties: false,
      patternProperties: {
        "^x-": {
          $ref: "#/definitions/specificationExtension"
        }
      },
      properties: {
        authorizationUrl: {
          type: "string"
        },
        tokenUrl: {
          type: "string"
        },
        refreshUrl: {
          type: "string"
        },
        scopes: {
          $ref: "#/definitions/strings"
        }
      }
    },
    securityRequirement: {
      type: "object",
      description: "Lists the required security schemes to execute this operation. The name used for each property MUST correspond to a security scheme declared in the Security Schemes under the Components Object.  Security Requirement Objects that contain multiple schemes require that all schemes MUST be satisfied for a request to be authorized. This enables support for scenarios where multiple query parameters or HTTP headers are required to convey security information.  When a list of Security Requirement Objects is defined on the Open API object or Operation Object, only one of Security Requirement Objects in the list needs to be satisfied to authorize the request.",
      additionalProperties: false,
      patternProperties: {
        "^[a-zA-Z0-9\\.\\-_]+$": {
          type: "array",
          items: {
            type: "string"
          },
          uniqueItems: true
        }
      }
    },
    anyOrExpression: {
      oneOf: [
        {
          $ref: "#/definitions/any"
        },
        {
          $ref: "#/definitions/expression"
        }
      ]
    },
    callbackOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/callback"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    exampleOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/example"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    headerOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/header"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    linkOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/link"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    parameterOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/parameter"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    requestBodyOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/requestBody"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    responseOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/response"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    pathItemsOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/pathItem"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    schemaOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/schema"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    securitySchemeOrReference: {
      oneOf: [
        {
          $ref: "#/definitions/securityScheme"
        },
        {
          $ref: "#/definitions/reference"
        }
      ]
    },
    anysOrExpressions: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/anyOrExpression"
      }
    },
    callbacksOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/callbackOrReference"
      }
    },
    encodings: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/encoding"
      }
    },
    examplesOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/exampleOrReference"
      }
    },
    headersOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/headerOrReference"
      }
    },
    linksOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/linkOrReference"
      }
    },
    mediaTypes: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/mediaType"
      }
    },
    parametersOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/parameterOrReference"
      }
    },
    requestBodiesOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/requestBodyOrReference"
      }
    },
    responsesOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/responseOrReference"
      }
    },
    schemasOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/schemaOrReference"
      }
    },
    securitySchemesOrReferences: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/securitySchemeOrReference"
      }
    },
    serverVariables: {
      type: "object",
      additionalProperties: {
        $ref: "#/definitions/serverVariable"
      }
    },
    strings: {
      type: "object",
      additionalProperties: {
        type: "string"
      }
    },
    object: {
      type: "object",
      additionalProperties: true
    },
    any: {
      type: "object",
      additionalProperties: true
    },
    expression: {
      type: "object",
      additionalProperties: true
    },
    specificationExtension: {
      description: "Any property starting with x- is valid.",
      oneOf: [
        {
          type: "null"
        },
        {
          type: "number"
        },
        {
          type: "boolean"
        },
        {
          type: "string"
        },
        {
          type: "object"
        },
        {
          type: "array"
        }
      ]
    },
    defaultType: {
      oneOf: [
        {
          type: "null"
        },
        {
          type: "array"
        },
        {
          type: "object"
        },
        {
          type: "number"
        },
        {
          type: "boolean"
        },
        {
          type: "string"
        }
      ]
    }
  }
};

// src/internal/Validator/index.ts
var showLogs = (logs, logger) => {
  if (logger?.displayLogLines && logger.displayLogLines > 0) {
    const latestLogs = logs.slice(0, logger.displayLogLines);
    const moreLogNum = logs.length - latestLogs.length;
    console.error("Correct the validation error before generating the code.");
    console.error(`There are a total of ${logs.length} errors below.`);
    console.error("");
    console.error(latestLogs);
    console.error("");
    if (moreLogNum > 0) {
      console.error(`more ${moreLogNum} error logs`);
      console.error("");
    }
  } else {
    console.error("Correct the validation error before generating the code.");
    console.error(`There are a total of ${logs.length} errors below.`);
    console.error("");
    console.error(logs);
    console.error("");
  }
};
var validate = (openapiDoc, logger) => {
  const ajv = new Ajv.default({ allErrors: true });
  const validate2 = ajv.compile(openapi_default);
  validate2(openapiDoc);
  if (validate2.errors) {
    showLogs(validate2.errors, logger);
    throw new Error("Validation Error");
  }
};

// src/index.ts
var CodeGenerator = class {
  constructor(entryPointOrDocument, option) {
    this.entryPointOrDocument = entryPointOrDocument;
    this.option = option;
    if (typeof entryPointOrDocument === "string") {
      this.rootSchema = FileSystem.loadJsonOrYaml(entryPointOrDocument);
      this.resolvedReferenceDocument = ResolveReference_exports.resolve(
        entryPointOrDocument,
        entryPointOrDocument,
        JSON.parse(JSON.stringify(this.rootSchema))
      );
    } else {
      this.rootSchema = entryPointOrDocument;
      this.resolvedReferenceDocument = ResolveReference_exports.resolve(".", ".", JSON.parse(JSON.stringify(this.rootSchema)));
    }
    this.parser = this.createParser();
  }
  rootSchema;
  resolvedReferenceDocument;
  parser;
  createParser() {
    const entryPoint = typeof this.entryPointOrDocument === "string" ? this.entryPointOrDocument : ".";
    return new OpenApiTools_exports.Parser(entryPoint, this.rootSchema, this.resolvedReferenceDocument, this.option?.convertOption);
  }
  /**
   * Validate the OpenAPI Schema
   */
  validateOpenApiSchema(option) {
    if (!option) {
      Validator_exports.validate(this.resolvedReferenceDocument);
    } else {
      Validator_exports.validate(this.resolvedReferenceDocument, option.logger);
    }
  }
  /**
   * Provides TypeScript typedefs generated from OpenAPI Schema.
   *
   * @param generatorTemplate Template for when you want to change the code following a type definition
   * @returns String of generated code
   */
  generateTypeDefinition(generatorTemplates, allowOperationIds) {
    const create49 = () => {
      const statements = this.parser.getOpenApiTypeDefinitionStatements();
      generatorTemplates?.forEach((generatorTemplate) => {
        const payload = this.parser.getCodeGeneratorParamsArray(allowOperationIds);
        const extraStatements = TsGenerator_exports.Utils.convertIntermediateCodes(generatorTemplate.generator(payload, generatorTemplate.option));
        statements.push(...extraStatements);
      });
      return statements;
    };
    return [OpenApiTools_exports.Comment.generateLeading(this.resolvedReferenceDocument), TsGenerator_exports.generate(create49)].join(import_os5.EOL + import_os5.EOL + import_os5.EOL);
  }
  /**
   * Generate code using a template
   *
   * @param generatorTemplate
   * @returns String of generated code
   */
  generateCode(generatorTemplates, allowOperationIds) {
    const payload = this.parser.getCodeGeneratorParamsArray(allowOperationIds);
    const create49 = () => {
      return generatorTemplates.flatMap((generatorTemplate) => {
        return TsGenerator_exports.Utils.convertIntermediateCodes(generatorTemplate?.generator(payload, generatorTemplate.option));
      });
    };
    return [OpenApiTools_exports.Comment.generateLeading(this.resolvedReferenceDocument), TsGenerator_exports.generate(create49)].join(import_os5.EOL + import_os5.EOL + import_os5.EOL);
  }
  /**
   * Provides parameters extracted from OpenApi Schema
   */
  getCodeGeneratorParamsArray(allowOperationIds) {
    return this.parser.getCodeGeneratorParamsArray(allowOperationIds);
  }
  /**
   * Provides types for parameters for Templates.FunctionalApiClient.
   *
   * This API will be moved to Templates in the future.
   */
  getAdditionalTypeDefinitionCustomCodeGenerator() {
    return {
      generator: () => this.parser.getAdditionalTypeStatements()
    };
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CodeGenerator
});
//# sourceMappingURL=index.cjs.map