"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/meta.ts
var meta_exports = {};
__export(meta_exports, {
  Name: () => Name,
  Version: () => Version
});
module.exports = __toCommonJS(meta_exports);

// package.json
var package_default = {
  name: "@himenon/openapi-typescript-code-generator",
  version: "1.0.11",
  description: "OpenAPI Code Generator using TypeScript AST.",
  keywords: [
    "openapi",
    "openapi3",
    "openapi-codegen",
    "openapi-generator",
    "typescript",
    "typescript-ast"
  ],
  homepage: "https://github.com/Himenon/openapi-typescript-code-generator#readme",
  bugs: {
    url: "https://github.com/Himenon/openapi-typescript-code-generator/issues"
  },
  repository: {
    type: "git",
    url: "git@github.com:Himenon/openapi-typescript-code-generator.git"
  },
  license: "MIT",
  author: {
    name: "Himenon",
    email: "k.himeno314@gmail.com",
    url: "https://github.com/Himenon"
  },
  sideEffects: false,
  type: "module",
  exports: {
    ".": {
      import: "./dist/index.js",
      require: "./dist/index.cjs"
    },
    "./dist/api": {
      import: "./dist/api.js",
      require: "./dist/api.cjs"
    },
    "./dist/templates": {
      import: "./dist/templates.js",
      require: "./dist/templates.cjs"
    },
    "./dist/types": {
      import: "./dist/types.js",
      require: "./dist/types.cjs"
    },
    "./dist/meta": {
      import: "./dist/meta.js",
      require: "./dist/meta.cjs"
    }
  },
  main: "./dist/index.js",
  module: "./dist/index.js",
  browser: "./dist/index.js",
  types: "./dist/index.d.ts",
  files: [
    "dist",
    "package.json"
  ],
  scripts: {
    lint: "biome lint .",
    format: "biome format --write .",
    build: "tsup",
    clean: "pnpm ts ./scripts/clean.ts",
    "lerna:version:up": "lerna version --yes",
    "release:github:registry": "pnpm publish  --no-git-checks --registry https://npm.pkg.github.com/:_authToken=${NODE_AUTH_TOKEN}",
    "release:npm:registry": "pnpm publish --no-git-checks",
    test: "run-p test:depcruise test:jest test:code:gen:* test:snapshot",
    "test:code:gen": "run-p test:code:gen:*",
    "test:code:gen:class": "pnpm ts ./scripts/testCodeGenWithClass.ts",
    "test:code:gen:function": "pnpm ts ./scripts/testCodeGenWithFunctional.ts",
    "test:code:gen:currying-function": "pnpm ts ./scripts/testCodeGenWithCurryingFunctional.ts",
    "test:depcruise": "depcruise --validate .dependency-cruiser.cjs src",
    "test:jest": "cross-env NODE_OPTIONS=--experimental-specifier-resolution=node jest -c ./jest.config.cjs --collect-coverage",
    "test:snapshot": "jest -c ./jest.snapshot.config.cjs",
    ts: "node --no-warnings=ExperimentalWarning --experimental-specifier-resolution=node --loader ts-node/esm",
    "update:snapshot": "pnpm jest -c ./jest.snapshot.config.cjs --updateSnapshot",
    watch: "pnpm ts ./scripts/watch.ts",
    validate: "pnpm ts ./scripts/validate.ts"
  },
  "simple-git-hooks": {
    "pre-commit": "pnpm lint-staged"
  },
  "lint-staged": {
    "*.{js,jsx,json,yml,yaml,html,md,ts,tsx}": [
      "biome format --no-errors-on-unmatched --write"
    ],
    "package.json": [
      "sort-package-json"
    ]
  },
  resolutions: {
    "kind-of": "6.0.3",
    "node-fetch": "2.6.1"
  },
  dependencies: {
    "@types/json-schema": "7.0.15",
    ajv: "8.12.0",
    "js-yaml": "4.1.0"
  },
  devDependencies: {
    "@biomejs/biome": "^1.9.4",
    "@commitlint/cli": "18.6.0",
    "@commitlint/config-conventional": "18.6.0",
    "@himenon/path-oriented-data-structure": "1.0.2",
    "@swc/core": "^1.9.3",
    "@swc/helpers": "^0.5.15",
    "@swc/jest": "^0.2.37",
    "@types/chokidar": "2.1.3",
    "@types/jest": "29.5.12",
    "@types/js-yaml": "4.0.9",
    "@types/node": "20.11.16",
    "@types/rimraf": "3.0.2",
    chokidar: "3.5.3",
    "conventional-changelog-angular-all": "1.7.0",
    cpy: "11.0.0",
    "cross-env": "^7.0.3",
    "dependency-cruiser": "16.1.0",
    "dot-prop": "8.0.2",
    execa: "8.0.1",
    "generate-changelog": "1.8.0",
    "import-sort-style-module": "6.0.0",
    jest: "29.7.0",
    "jest-cli": "29.7.0",
    lerna: "8.0.2",
    "lint-staged": "15.2.1",
    "npm-run-all": "4.1.5",
    "openapi-schema-validator": "12.1.3",
    "read-package-up": "^11.0.0",
    rimraf: "5.0.5",
    "simple-git-hooks": "^2.11.1",
    "sort-package-json": "2.7.0",
    "ts-jest": "29.1.2",
    "ts-node": "10.9.2",
    tsup: "^8.3.5",
    typescript: "5.3.3"
  },
  peerDependencies: {
    typescript: ">=5"
  },
  engines: {
    pnpm: ">=9"
  },
  publishConfig: {
    access: "public"
  },
  importSort: {
    ".js, .jsx, .ts, .tsx": {
      style: "module",
      parser: "typescript"
    }
  }
};

// src/meta.ts
var Name = package_default.name;
var Version = package_default.version;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Name,
  Version
});
//# sourceMappingURL=meta.cjs.map