"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/utils.ts
var utils_exports = {};
__export(utils_exports, {
  argumentParamsTypeDeclaration: () => argumentParamsTypeDeclaration,
  escapeText: () => escapeText,
  escapeText2: () => escapeText2,
  isAvailableVariableName: () => isAvailableVariableName,
  isFirstCharacterIsValidText: () => isFirstCharacterIsValidText,
  parameterName: () => parameterName,
  requestBodyName: () => requestBodyName,
  requestContentType: () => requestContentType,
  responseContentType: () => responseContentType,
  responseName: () => responseName
});
module.exports = __toCommonJS(utils_exports);
var parameterName = (operationId) => `Parameter$${operationId}`;
var requestBodyName = (operationId) => `RequestBody$${operationId}`;
var argumentParamsTypeDeclaration = (operationId) => `Params$${operationId}`;
var responseName = (operationId, statusCode) => `Response$${operationId}$Status$${statusCode}`;
var requestContentType = (operationId) => `RequestContentType$${operationId}`;
var responseContentType = (operationId) => `ResponseContentType$${operationId}`;
var isAvailableVariableName = (text) => {
  return /^[A-Za-z_0-9]+$/.test(text);
};
var isFirstCharacterIsValidText = (text) => {
  return /^[A-Za-z]+/.test(text);
};
var escapeText = (text) => {
  if (isAvailableVariableName(text) && isFirstCharacterIsValidText(text)) {
    return text;
  }
  return `"${text}"`;
};
var escapeText2 = (text) => {
  if (isAvailableVariableName(text)) {
    return {
      escaped: false,
      text
    };
  }
  return {
    escaped: true,
    text: `"${text}"`
  };
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  argumentParamsTypeDeclaration,
  escapeText,
  escapeText2,
  isAvailableVariableName,
  isFirstCharacterIsValidText,
  parameterName,
  requestBodyName,
  requestContentType,
  responseContentType,
  responseName
});
//# sourceMappingURL=utils.cjs.map